#include "file_operate.h"
#include "help.h"
#include "id3.h"
#include "instance.h"
gvoid About() {
    GtkWidget *about_dialog;
    const gchar *authors[] = {"slax.jiacheng from Canton Guangdong China ", NULL };
    gchar *translators = "translator-credits";
    about_dialog = gtk_about_dialog_new ();
    gtk_container_set_border_width (GTK_CONTAINER (about_dialog), 5);
    gtk_window_set_destroy_with_parent (GTK_WINDOW (about_dialog), TRUE);
    gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (about_dialog), version);
    gtk_about_dialog_set_name (GTK_ABOUT_DIALOG (about_dialog), "IcePlayer");
    gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG (about_dialog),"My music player.if you have any question,please e-mail to me , i will try my best to help you ! 2010 GPL");
    gtk_about_dialog_set_website (GTK_ABOUT_DIALOG (about_dialog), "http://jasy.ice.blog.163.com");
    gtk_about_dialog_set_website_label (GTK_ABOUT_DIALOG (about_dialog), "Blog:jasy.ice.blog.163.com \nE-mail:jasy.ice@163.com\nQQ:173870074");
    gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (about_dialog), authors);
    gtk_about_dialog_set_translator_credits (GTK_ABOUT_DIALOG (about_dialog), translators);
    GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
    gtk_window_set_icon(GTK_WINDOW(about_dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
    gtk_window_set_keep_above     (GTK_WINDOW (about_dialog),TRUE);
    gtk_dialog_run((GtkDialog *) about_dialog);
    gtk_widget_destroy(about_dialog);
}
gvoid set_volume(gdouble volume2) {

    if (volume2>1.0) volume2=1.0;
    if (volume2<0.08) volume2=0.0;
    if (pipeline) {
        vol=gst_bin_get_by_name(GST_BIN(pipeline), "volume");
        if (!vol) return;
        g_object_set(vol, "volume",volume2, NULL);
    }
    volume=volume2;
}
gvoid set_process_value (gdouble value) {
    goto_line();
    if (value<7.0)value=7.0;
    if (value>193.0)value=193.0;
    if (value>=0)gtk_widget_set_size_request (eventbox_process_prev,value,12);
    if (200.0-value>=0) gtk_widget_set_size_request (eventbox_process_next,200.0-value,12);
}
gvoid set_volume_value (gdouble value)  {
    if (value<7.0)value=0.0;
    if (value>63.0)value=63.0;
    if (pipeline) {
        set_volume(value/100.0);
    }
    if (value<7.0) {
        gtk_widget_set_size_request (eventbox_volume_prev,7,12);
        gtk_widget_set_size_request (eventbox_volume_next,63,12);
    } else {
        if (value>=0)gtk_widget_set_size_request (eventbox_volume_prev,value,12);
        if (70-value>=0)gtk_widget_set_size_request (eventbox_volume_next,70-value,12);
    }
}
gboolean update_time() {
    if (pipeline&&(play_state!=IcePlayer_Play_State_STOP)) {
        gst_element_query_position(pipeline, &fmt, &pos);
        gst_element_query_duration(pipeline, &fmt, &length);
        if (save_use_desktop_lrc) {
            close_widget_lrc();
            desktop_lrc_run();
        } else {
            close_desktop_lrc();
            widget_lrc_run();
        }
        if (length>=0) {
            gchar A[60];
            gchar B[25];
            if (pos<=length&&!process_timer) {
                set_process_value((gdouble) pos/(gdouble) length*190.0+6);
            }
            g_snprintf(A,24,"%02u.%02u:%02u%d",GST_TIME_ARGS(pos));
            g_snprintf(B,24,"%02u.%02u:%02u%d",GST_TIME_ARGS(length));

            A[8] = 0;
            B[8] = 0;
            strcat(A,"-");
            strcat(A,B);
            if (strlen(A)==17) {
                gtk_label_set_text(GTK_LABEL(label_info3),A);
            }
        }
    }

    gint width,height;
    gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
    if (width!=300||height<=170) {
        if (height!=3) {
            gtk_window_unfullscreen((GtkWindow *)IcePlayer) ;
            gtk_window_unmaximize ((GtkWindow *)IcePlayer);
            gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
            if (width!=300||height<=170)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
            return TRUE;
        }
    }
    if (show_min) {
        gint x,y;
        gint sx,sy;
        gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
        gdk_window_get_pointer( NULL,&sx,&sy,NULL);

        if ((focus&&sy<=13)||((!show_iceplayer)&&y<=10&&sy<=13&&sx>x-20&&sx<x+width+20)) {
            if (!drag_lock) {
                if (height2>170)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
                gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),TRUE);
            }
            return TRUE;
        }
        if ((!focus&&y<=10&&((sx<x-20||sx>=x+width+20)||(sy>=height2+20)))||((!show_iceplayer)&&y<=10&&((sx<x-20||sx>=x+width+20)||(sy>=height2+20)))) {
            if (!drag_lock) {
                if (height!=3)height2 = height;
                gtk_window_resize((GtkWindow *)IcePlayer,300,3);
                gtk_window_move((GtkWindow *)IcePlayer,x,0);
                gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),TRUE);
            } else {
                if (height2>170) gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
            }
            return TRUE;
        }
        if (y>10)gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),FALSE);
    } else {
        if (height<170)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
    }
    if (height>170)height2 = height;
    return TRUE;
}
gvoid Play_Type(GtkMenuItem *item, gpointer user_data) /**/ { /*   切换播放模式    */
    const gchar *title = gtk_label_get_label((GtkLabel  *)GTK_BIN (item)->child);
    if (!strcmp(title,"顺序播放")) {
        play_type = IcePlayer_Play_Mode_Normal;
    }
    if (!strcmp(title,"随机播放")) {
        play_type = IcePlayer_Play_Mode_Radom;
    }
    if (!strcmp(title,"单曲循环")) {
        play_type = IcePlayer_Play_Mode_One;
    }
    if (!strcmp(title,"列表循环")) {
        play_type = IcePlayer_Play_Mode_Normal_Round;
    }
}
gboolean timer_process() {
    gint x,y;
    gint sx,sy;
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    gdk_window_get_pointer( NULL,&sx,&sy,NULL);
    set_process_value(sx-x-12);
    return process_timer;
}
gboolean timer_volume() {
    gint x,y;
    gint sx,sy;
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    gdk_window_get_pointer( NULL,&sx,&sy,NULL);
    set_volume_value(sx-x-220);
    return volume_timer;
}
gboolean on_enter_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        GdkCursor* cursor = gdk_cursor_new(GDK_SB_V_DOUBLE_ARROW);
        gdk_window_set_cursor(GTK_WIDGET(widget)->window, cursor);
        gdk_cursor_destroy(cursor);
        break;
    }
    case 1: {
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        if (play_state!=IcePlayer_Play_State_PLAYING)
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play_enter,TRUE,NULL));
        else
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause_enter,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        return TRUE;
    }
    case 2: {
        gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
        image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev_enter,TRUE,NULL));
        gtk_widget_show(image_prev);
        gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
        return TRUE;
    }
    case 3: {
        gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
        image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next_enter,TRUE,NULL));
        gtk_widget_show(image_next);
        gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
        return TRUE;
    }
    case 4: {
        gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
        image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop_enter,TRUE,NULL));
        gtk_widget_show(image_stop);
        gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
        return TRUE;
    }
    case 5: {
        gtk_container_remove(GTK_CONTAINER(eventbox_min),image_min);
        image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min_enter,TRUE,NULL));
        gtk_widget_show(image_min);
        gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
        return TRUE;
    }
    case 6: {
        gtk_container_remove(GTK_CONTAINER(eventbox_close),image_close);
        image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close_enter,TRUE,NULL));
        gtk_widget_show(image_close);
        gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
        return TRUE;
    }
    case 7: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add_enter,TRUE,NULL));
        gtk_widget_show(image_tools_add);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        return TRUE;
    }
    case 8: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele_enter,TRUE,NULL));
        gtk_widget_show(image_tools_dele);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        return TRUE;
    }
    case 9: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list_enter,TRUE,NULL));
        gtk_widget_show(image_tools_list);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        return TRUE;
    }
    case 10: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode_enter,TRUE,NULL));
        gtk_widget_show(image_tools_mode);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        return TRUE;
    }
    case 11: {
        gtk_window_set_focus(GTK_WINDOW(IcePlayer),treeview);
        return TRUE;
    }
    case 12: {
        gtk_container_remove(GTK_CONTAINER(eventbox_process_node),image_process_node);
        image_process_node=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_node_enter,TRUE,NULL));
        gtk_widget_show(image_process_node);
        gtk_container_add(GTK_CONTAINER(eventbox_process_node),image_process_node);
        return TRUE;
    }
    case 13: {
        gtk_container_remove(GTK_CONTAINER(eventbox_volume_node),image_volume_node);
        image_volume_node=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_node_enter,TRUE,NULL));
        gtk_widget_show(image_volume_node);
        gtk_container_add(GTK_CONTAINER(eventbox_volume_node),image_volume_node);
        return TRUE;
    }
    }
    return TRUE;
}
gboolean on_leave_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        gdk_window_set_cursor(GTK_WIDGET(widget)->window, NULL);
        break;
    }
    case 1: {
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        if (play_state!=IcePlayer_Play_State_PLAYING)
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
        else
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        return TRUE;
    }
    case 2: {
        gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
        image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev,TRUE,NULL));
        gtk_widget_show(image_prev);
        gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
        return TRUE;
    }
    case 3: {
        gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
        image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next,TRUE,NULL));
        gtk_widget_show(image_next);
        gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
        return TRUE;
    }
    case 4: {
        gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
        image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop,TRUE,NULL));
        gtk_widget_show(image_stop);
        gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
        return TRUE;
    }
    case 5: {
        gtk_container_remove(GTK_CONTAINER(eventbox_min),image_min);
        image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min,TRUE,NULL));
        gtk_widget_show(image_min);
        gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
        return TRUE;
    }
    case 6: {
        gtk_container_remove(GTK_CONTAINER(eventbox_close),image_close);
        image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close,TRUE,NULL));
        gtk_widget_show(image_close);
        gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
        return TRUE;
    }
    case 7: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add,TRUE,NULL));
        gtk_widget_show(image_tools_add);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        return TRUE;
    }
    case 8: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele,TRUE,NULL));
        gtk_widget_show(image_tools_dele);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        return TRUE;
    }
    case 9: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list,TRUE,NULL));
        gtk_widget_show(image_tools_list);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        return TRUE;
    }
    case 10: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode,TRUE,NULL));
        gtk_widget_show(image_tools_mode);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        return TRUE;
    }
    case 12: {
        gtk_container_remove(GTK_CONTAINER(eventbox_process_node),image_process_node);
        image_process_node=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_node,TRUE,NULL));
        gtk_widget_show(image_process_node);
        gtk_container_add(GTK_CONTAINER(eventbox_process_node),image_process_node);
        return TRUE;
    }
    case 13: {
        gtk_container_remove(GTK_CONTAINER(eventbox_volume_node),image_volume_node);
        image_volume_node=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_node,TRUE,NULL));
        gtk_widget_show(image_volume_node);
        gtk_container_add(GTK_CONTAINER(eventbox_volume_node),image_volume_node);
        return TRUE;
    }
    }
    return TRUE ;
}
gboolean on_press_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        gtk_container_remove(GTK_CONTAINER(eventbox_close),image_close);
        image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close_on,TRUE,NULL));
        gtk_widget_show(image_close);
        gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
        return TRUE;
    }
    case 1 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_min),image_min);
        image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min_on,TRUE,NULL));
        gtk_widget_show(image_min);
        gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
        return TRUE;
    }
    case 2: {
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        if (play_state!=IcePlayer_Play_State_PLAYING)
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play_on,TRUE,NULL));
        else
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause_on,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        return TRUE;
    }
    case 3 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
        image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev_on,TRUE,NULL));
        gtk_widget_show(image_prev);
        gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
        return TRUE;
    }
    case 4: {
        gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
        image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next_on,TRUE,NULL));
        gtk_widget_show(image_next);
        gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
        return TRUE;
    }
    case 5 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
        image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop_on,TRUE,NULL));
        gtk_widget_show(image_stop);
        gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
        return TRUE;
    }
    case 6 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add_on,TRUE,NULL));
        gtk_widget_show(image_tools_add);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        return TRUE;
    }
    case 7: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele_on,TRUE,NULL));
        gtk_widget_show(image_tools_dele);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        return TRUE;
    }
    case 8: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list_on,TRUE,NULL));
        gtk_widget_show(image_tools_list);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        return TRUE;
    }
    case  9: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode_on,TRUE,NULL));
        gtk_widget_show(image_tools_mode);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        return TRUE;
    }
    case 10: {
        drag_lock=TRUE;
        gtk_window_begin_resize_drag(GTK_WINDOW(IcePlayer),6,event->button,event->x_root,event->y_root,event->time);
        return TRUE;
    }
    case 11 : {
        drag_lock=TRUE;
        gtk_window_begin_resize_drag(GTK_WINDOW(IcePlayer),1,event->button,event->x_root,event->y_root,event->time);
        return TRUE;
    }
    case 12: {
        drag_lock=TRUE;
        gtk_window_begin_resize_drag(GTK_WINDOW(IcePlayer),6,event->button,event->x_root,event->y_root,event->time);
        return TRUE;
    }
    case 13: {
        if (event->button==3&&event->type==GDK_BUTTON_PRESS) { /*在窗口右击时*/
            GtkWidget * menu = gtk_menu_new();
            GtkWidget *menu_config = gtk_image_menu_item_new_with_label("配置");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_config),gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU));

            GtkWidget *traymenuItemlrc_use_lrc;
            if (!show_lrc)traymenuItemlrc_use_lrc = gtk_image_menu_item_new_with_label("使用歌词");
            else traymenuItemlrc_use_lrc = gtk_image_menu_item_new_with_label("关闭歌词");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemlrc_use_lrc),gtk_image_new_from_stock ("gtk-unindent", GTK_ICON_SIZE_MENU));

            GtkWidget *traymenuItemlrc_change = NULL;
            if (show_lrc) {
                if (save_use_desktop_lrc) traymenuItemlrc_change= gtk_image_menu_item_new_with_label("桌面歌词->窗口歌词");
                else traymenuItemlrc_change = gtk_image_menu_item_new_with_label("窗口歌词->桌面歌词");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemlrc_change),gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU));
            }
            GtkWidget *traymenuItemLrc = NULL ;
            if (show_lrc&&save_use_desktop_lrc) {
                if (save_lrc_no_has_press_event) {
                    traymenuItemLrc= gtk_image_menu_item_new_with_label("取消鼠标穿透");
                } else {
                    traymenuItemLrc = gtk_image_menu_item_new_with_label("使用鼠标穿透");
                }
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemLrc),gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_MENU));
            }
            GtkWidget *menu_help = gtk_image_menu_item_new_with_label("帮助");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_help),gtk_image_new_from_stock ("gtk-help",GTK_ICON_SIZE_MENU));

            GtkWidget *menu_about = gtk_image_menu_item_new_with_label("关于");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_about),gtk_image_new_from_stock ("gtk-about",GTK_ICON_SIZE_MENU));

            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_config);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),traymenuItemlrc_use_lrc);
            if (show_lrc)gtk_menu_shell_append(GTK_MENU_SHELL(menu),traymenuItemlrc_change);
            if (show_lrc&&save_use_desktop_lrc)gtk_menu_shell_append(GTK_MENU_SHELL(menu),traymenuItemLrc);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_help);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_about);

            g_signal_connect(menu_config,"activate",G_CALLBACK(Config),NULL);
            g_signal_connect(menu_help,"activate",G_CALLBACK(Help),NULL);
            g_signal_connect(menu_about,"activate",G_CALLBACK(About),NULL);
            g_signal_connect((gpointer) traymenuItemlrc_use_lrc,"activate" ,G_CALLBACK(change_use_lrc),NULL);
            if (show_lrc)g_signal_connect((gpointer) traymenuItemlrc_change,"activate" ,G_CALLBACK(change_use_desktop_or_widget),NULL);
            if (show_lrc&&save_use_desktop_lrc)g_signal_connect((gpointer) traymenuItemLrc ,"activate" ,G_CALLBACK(change_desktop_lrc_has_press_event),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup_new(GTK_MENU(menu),3,3);
        } else {
            drag_lock=TRUE;
            gint width,height;
            gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
            height2 = height;
            gtk_window_begin_move_drag(GTK_WINDOW(IcePlayer),event->button,event->x_root,event->y_root,event->time);
        }
        return FALSE;
    }
    case 14: {
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (event->type==GDK_2BUTTON_PRESS) {
            play_path = (GtkTreePath *) list->data;
            change_treeview_uri();
            play_uri();
            return FALSE;
        }
        if (event->button==3) {
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
            GList *list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);

            if (!list) {
                GtkWidget * menu = gtk_menu_new();
                GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_mnemonic("添加文件");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_Open_file),gtk_image_new_from_stock ("gtk-open",GTK_ICON_SIZE_MENU));

                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file);
                GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_mnemonic("添加文件夹");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_Open_folder),gtk_image_new_from_stock ("gtk-open",GTK_ICON_SIZE_MENU));

                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder);
                g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
                g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
                gtk_widget_show_all(menu);
                drag_lock=TRUE;
                gtk_menu_popup_new(GTK_MENU(menu),1,1);
                return FALSE;
            }
            GtkWidget * menu = gtk_menu_new();
            /**/
            GtkWidget *menu_go;
            if (play_state == IcePlayer_Play_State_PLAYING) {
                menu_go = gtk_image_menu_item_new_with_label("暂停");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_go), gtk_image_new_from_stock ("gtk-media-pause", GTK_ICON_SIZE_MENU));
            } else {
                menu_go = gtk_image_menu_item_new_with_label("播放");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_go), gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_MENU));
            }
            GtkWidget *menu_prev = gtk_image_menu_item_new_with_label("上一首");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_prev), gtk_image_new_from_stock ("gtk-media-previous", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_next = gtk_image_menu_item_new_with_label("下一首");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_next), gtk_image_new_from_stock ("gtk-media-next", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_stop = gtk_image_menu_item_new_with_label("停止");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_stop), gtk_image_new_from_stock ("gtk-media-stop", GTK_ICON_SIZE_MENU));
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_go );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_prev );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_next );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_stop );
            g_signal_connect(menu_go ,"activate",G_CALLBACK(play),NULL);
            g_signal_connect(menu_prev ,"activate",G_CALLBACK(prev),NULL);
            g_signal_connect(menu_next ,"activate",G_CALLBACK(next),NULL);
            g_signal_connect(menu_stop ,"activate",G_CALLBACK(stop),NULL);
            /**/
            GtkWidget *menu_separator1 = gtk_separator_menu_item_new ();
            GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_label("添加文件");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_Open_file), gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_label("添加文件夹");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_Open_folder), gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_MENU));
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator1 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder );
            g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
            g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
            /**/
            GtkWidget *menu_delete_menu= gtk_image_menu_item_new_with_label("删除...");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_delete_menu),gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_delete_sub = gtk_menu_new();
            GtkWidget *menu_separator2 = gtk_separator_menu_item_new ();
            GtkWidget *menu_delete = gtk_image_menu_item_new_with_label("移除选中的文件");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_delete), gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_delete_include_name = gtk_image_menu_item_new_with_label("移除包含\"???\"的文件");
            GtkWidget *menu_delete_all = gtk_image_menu_item_new_with_label("清空文件");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_delete_all),gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_delete_same = gtk_image_menu_item_new_with_label("移除重复的文件");
            GtkWidget *menu_real_delete = gtk_image_menu_item_new_with_label("物理删除选中的文件");
            GtkWidget *menu_delete_not_exist = gtk_image_menu_item_new_with_label("移除已不存在的文件");
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_delete_menu), menu_delete_sub);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator2 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_all );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_menu );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_delete_sub),menu_delete_include_name );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_delete_sub),menu_delete_same );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_delete_sub),menu_real_delete );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_delete_sub),menu_delete_not_exist );
            g_signal_connect(menu_delete ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_all ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_include_name ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_not_exist ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_same ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_real_delete ,"activate",G_CALLBACK(List_delete),NULL);
            /**/

            GtkWidget *menu_lrc_redownload_file_name = NULL;
            GtkWidget *menu_lrc_redownload_id3 = NULL;
            GtkWidget *menu_separator3 = NULL;
            if (show_lrc) {
                menu_separator3 = gtk_separator_menu_item_new ();
                menu_lrc_redownload_file_name = gtk_image_menu_item_new_with_label("搜索歌词(文件名)");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_lrc_redownload_file_name),gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_MENU));
                menu_lrc_redownload_id3 = gtk_image_menu_item_new_with_label("搜索歌词(歌曲ID3标签)");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_lrc_redownload_id3),gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_MENU));
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator3 );
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_lrc_redownload_file_name );
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_lrc_redownload_id3 );
                g_signal_connect(menu_lrc_redownload_file_name  ,"activate",G_CALLBACK(lrc_redownload),(gpointer)0);
                g_signal_connect(menu_lrc_redownload_id3  ,"activate",G_CALLBACK(lrc_redownload),(gpointer)1);
            }
            /**/
            GtkWidget *menu_separator4 = gtk_separator_menu_item_new ();
            GtkWidget *menu_list= gtk_image_menu_item_new_with_label("排列模式...");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_list),gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_list_sub = gtk_menu_new();
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_list), menu_list_sub);
            GtkWidget *menu_list_forward = gtk_image_menu_item_new_with_label("正序");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_list_forward), gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_list_backward = gtk_image_menu_item_new_with_label("反序");
            GtkWidget *menu_list_radom      = gtk_image_menu_item_new_with_label("乱序");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator4 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_list_sub),menu_list_forward);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_list_sub),menu_list_backward);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_list_sub),menu_list_radom);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            g_signal_connect(menu_list_forward ,"activate",G_CALLBACK(List_order),(gpointer)0);
            g_signal_connect(menu_list_backward ,"activate",G_CALLBACK(List_order),(gpointer)1);
            g_signal_connect(menu_list_radom ,"activate",G_CALLBACK(List_order),(gpointer)2);
            /**/

            GtkWidget *menu_file_operate_copy[50];
            GtkWidget *menu_file_operate_move[50];
            GtkWidget *menu_file_operate_link[50];
            gint menu_file_operate_number =0;
            DIR * dir,*dir_tmp;
            gchar media_path[50] = "/media/";
            gchar path[2000];
            struct dirent * ptr;
            dir=opendir("/media");
            ptr=readdir(dir);
            while (ptr) {
                if (strcmp(ptr->d_name,".")&&strcmp(ptr->d_name,"..")) {
                    strcpy(path,media_path);
                    strcat(path,ptr->d_name);
                    dir_tmp=opendir(path);
                    if (dir_tmp&&strncmp(ptr->d_name,"cdrom",5))  {
                        menu_file_operate_copy[menu_file_operate_number]=gtk_image_menu_item_new_with_label(ptr->d_name);
                        menu_file_operate_move[menu_file_operate_number]=gtk_image_menu_item_new_with_label(ptr->d_name);
                        menu_file_operate_link[menu_file_operate_number++]=gtk_image_menu_item_new_with_label(ptr->d_name);
                    }
                    if (dir_tmp)closedir(dir_tmp);
                }
                ptr=readdir(dir);
            }
            closedir(dir);
            menu_file_operate_copy[menu_file_operate_number]=gtk_image_menu_item_new_with_label("选择..");
            menu_file_operate_move[menu_file_operate_number]=gtk_image_menu_item_new_with_label("选择..");
            menu_file_operate_link[menu_file_operate_number++]=gtk_image_menu_item_new_with_label("选择..");
            gint m = menu_file_operate_number-1;
            GtkWidget *menu_file= gtk_image_menu_item_new_with_label("文件操作...");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_file),gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_file_sub = gtk_menu_new();
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_file), menu_file_sub);
            GtkWidget *menu_rename = gtk_image_menu_item_new_with_label("重命名...(F2)");
            GtkWidget *menu_open = gtk_image_menu_item_new_with_label("打开所在文件夹");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_open), gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_copy = gtk_image_menu_item_new_with_label("复制至...");
            GtkWidget *menu_copy_sub = gtk_menu_new();
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_copy), menu_copy_sub);
            GtkWidget *menu_move = gtk_image_menu_item_new_with_label("移动至...");
            GtkWidget *menu_move_sub = gtk_menu_new();
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_move), menu_move_sub);
            GtkWidget *menu_link = gtk_image_menu_item_new_with_label("链接至...");
            GtkWidget *menu_link_sub = gtk_menu_new();
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_link), menu_link_sub);
            gboolean has_copy,has_move,has_link;
            has_copy=has_move=has_link=TRUE;
            g_signal_connect(menu_rename ,"activate",G_CALLBACK(operate_file),(gpointer)IcePlayer_File_Operate_Rename);
            g_signal_connect(menu_open ,"activate",G_CALLBACK(operate_file),(gpointer)IcePlayer_File_Operate_Open);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_file );

            while (m+1) {
                g_signal_connect(menu_file_operate_copy[m] ,"activate",G_CALLBACK(operate_file),(gpointer)IcePlayer_File_Operate_Copy);
                g_signal_connect(menu_file_operate_move[m] ,"activate",G_CALLBACK(operate_file),(gpointer)IcePlayer_File_Operate_Move);
                g_signal_connect(menu_file_operate_link[m] ,"activate",G_CALLBACK(operate_file),(gpointer)IcePlayer_File_Operate_Link);
                if (has_copy) {
                    gtk_menu_shell_append(GTK_MENU_SHELL(menu_file_sub),menu_copy );
                    has_copy = FALSE;
                }
                if (has_move) {
                    gtk_menu_shell_append(GTK_MENU_SHELL(menu_file_sub),menu_move );
                    has_move = FALSE;
                }
                if (has_link) {
                    gtk_menu_shell_append(GTK_MENU_SHELL(menu_file_sub),menu_link );
                    has_link = FALSE;
                }
                gtk_menu_shell_append(GTK_MENU_SHELL(menu_copy_sub),menu_file_operate_copy[m] );
                gtk_menu_shell_append(GTK_MENU_SHELL(menu_move_sub),menu_file_operate_move[m] );
                gtk_menu_shell_append(GTK_MENU_SHELL(menu_link_sub),menu_file_operate_link[m] );
                m--;
            }

            gtk_menu_shell_append(GTK_MENU_SHELL(menu_file_sub),menu_rename );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_file_sub),menu_open );
            /**/
            GtkWidget *menu_mode= gtk_image_menu_item_new_with_label("播放模式...");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_mode),gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_mode_sub = gtk_menu_new();
            gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_mode), menu_mode_sub);
            GtkWidget *menu_normol = gtk_image_menu_item_new_with_label("顺序播放");
            GtkWidget *menu_radom = gtk_image_menu_item_new_with_label("随机播放");
            GtkWidget *menu_one = gtk_image_menu_item_new_with_label("单曲循环");
            GtkWidget *menu_normol_round = gtk_image_menu_item_new_with_label("列表循环");
            switch (play_type) {
            case IcePlayer_Play_Mode_Normal: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_normol), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_normol)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_normol)->child))));
            }
            break;
            case IcePlayer_Play_Mode_Radom: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_radom), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_radom )->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_radom )->child))));
            }
            break;
            case IcePlayer_Play_Mode_One: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_one), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_one)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_one)->child))));
            }
            break;
            case IcePlayer_Play_Mode_Normal_Round: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_normol_round), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_normol_round)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_normol_round)->child))));
            }
            break;
            }
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_mode );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),menu_normol );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),menu_radom );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),menu_one );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),menu_normol_round );

            g_signal_connect(menu_normol ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_radom ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_one ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_normol_round ,"activate",G_CALLBACK(Play_Type),NULL);


            GtkWidget *menu_separator5 = gtk_separator_menu_item_new ();
            GtkWidget *menu_id3 = gtk_image_menu_item_new_with_label("属性");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_id3),gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU));
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator5 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_id3);
            g_signal_connect(menu_id3 ,"activate",G_CALLBACK(edit_id3),NULL);

            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup_new(GTK_MENU(menu),3 ,3);
            if (list&&list->next) {
                return TRUE;
            }
        }
        return FALSE;
    }
    case 15: {
        if (pipeline&&play_state == IcePlayer_Play_State_PLAYING) {
            set_process_value(event->x+3);
            GstFormat fmt = GST_FORMAT_TIME;
            gint64 pos;
            gint64 length;
            gst_element_query_position(pipeline, &fmt, &pos);
            gst_element_query_duration(pipeline, &fmt, &length);
            pos = (((gdouble) event->x) / (gdouble) 200.0) * (gdouble) length;
            gint64 nanosec = (gdouble) pos/1000000000 * GST_SECOND;
            gst_element_seek(pipeline,1.0,GST_FORMAT_TIME,GST_SEEK_FLAG_FLUSH,GST_SEEK_TYPE_SET,nanosec,GST_SEEK_TYPE_NONE,GST_CLOCK_TIME_NONE);
        }
        return TRUE;
    }
    case  16: {
        if (pipeline&&play_state == IcePlayer_Play_State_PLAYING) {
            process_timer = TRUE;
            g_timeout_add(10, timer_process,NULL);
            return TRUE;
        }
    }
    case 17: {
        if (pipeline&&play_state == IcePlayer_Play_State_PLAYING) {
            gint x, y;
            gtk_widget_get_size_request(eventbox_process_prev,&x,&y);
            set_process_value(event->x+x+7);
            GstFormat fmt = GST_FORMAT_TIME;
            gint64 pos;
            gint64 length;
            gst_element_query_position(pipeline, &fmt, &pos);
            gst_element_query_duration(pipeline, &fmt, &length);
            pos = (((gdouble) event->x+x+7) / (gdouble) 200.0) * (gdouble) length;
            gint64 nanosec = (gdouble) pos/1000000000 * GST_SECOND;
            gst_element_seek(pipeline,1.0,GST_FORMAT_TIME,GST_SEEK_FLAG_FLUSH,GST_SEEK_TYPE_SET,nanosec,GST_SEEK_TYPE_NONE,GST_CLOCK_TIME_NONE);
        }
        return TRUE;
    }
    case 18: {
        set_volume_value(event->x);
        return TRUE;
    }
    case 19: {
        volume_timer = TRUE;
        g_timeout_add(10, timer_volume,NULL);
        return TRUE;
    }
    case 20: {
        gint x,y;
        gtk_widget_get_size_request(eventbox_volume_prev,&x,&y);
        set_volume_value(event->x+x+10);
        return TRUE;
    }
    }
    return TRUE;
}
gboolean on_release_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            quit();
        }
        return TRUE;
    }
    case 1: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            hide();
        }
        return TRUE;
    }
    case 2: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            play();
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            if (play_state!=IcePlayer_Play_State_PLAYING)
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
            else
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        }
        return TRUE;
    }
    case 3: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
            image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev,TRUE,NULL));
            gtk_widget_show(image_prev);
            gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
            prev();
        }
        return TRUE;
    }
    case 4  : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
            image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next,TRUE,NULL));
            gtk_widget_show(image_next);
            gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
            next();
        }
        return TRUE;
    }
    case 5  : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
            image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop,TRUE,NULL));
            gtk_widget_show(image_stop);
            gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
            stop();
        }
        return TRUE;
    }
    case  6 : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget * menu = gtk_menu_new();
            GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_label("添加文件");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file);
            GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_label("添加文件夹");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder);
            g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
            g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup_new(GTK_MENU(menu),3,3);
        }
        return TRUE;
    }
    case 7  : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget * menu = gtk_menu_new();
            GtkWidget *menu_delete = gtk_image_menu_item_new_with_label("移除选中的文件");
            GtkWidget *menu_delete_include_name = gtk_image_menu_item_new_with_label("移除包含\"???\"的文件");
            GtkWidget *menu_delete_all = gtk_image_menu_item_new_with_label("清空文件");
            GtkWidget *menu_delete_same = gtk_image_menu_item_new_with_label("移除重复的文件");
            GtkWidget *menu_delete_not_exist = gtk_image_menu_item_new_with_label("移除已不存在的文件");
            GtkWidget *menu_real_delete = gtk_image_menu_item_new_with_label("物理删除选中的文件");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_include_name );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_all );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_same );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_not_exist );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_real_delete );
            g_signal_connect(menu_delete ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_all ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_include_name ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_not_exist ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_same ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_real_delete ,"activate",G_CALLBACK(List_delete),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup_new(GTK_MENU(menu),3,3);
        }
        return TRUE;
    }
    case  8 : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget *menu = gtk_menu_new();
            GtkWidget *menu_list_forward = gtk_image_menu_item_new_with_label("正序");
            GtkWidget *menu_list_backward = gtk_image_menu_item_new_with_label("反序");
            GtkWidget *menu_list_radom      = gtk_image_menu_item_new_with_label("乱序");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_forward);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_backward);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_radom);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            g_signal_connect(menu_list_forward ,"activate",G_CALLBACK(List_order),(gpointer)0);
            g_signal_connect(menu_list_backward ,"activate",G_CALLBACK(List_order),(gpointer)1);
            g_signal_connect(menu_list_radom ,"activate",G_CALLBACK(List_order),(gpointer)2);
            gtk_menu_popup_new(GTK_MENU(menu),3 ,3);
        }
        return TRUE;
    }
    case   9: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget *menu = gtk_menu_new();
            GtkWidget *menu_normol = gtk_image_menu_item_new_with_label("顺序播放");
            GtkWidget *menu_radom = gtk_image_menu_item_new_with_label("随机播放");
            GtkWidget *menu_one = gtk_image_menu_item_new_with_label("单曲循环");
            GtkWidget *menu_normol_round = gtk_image_menu_item_new_with_label("列表循环");
            switch (play_type) {
            case IcePlayer_Play_Mode_Normal: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_normol), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_normol)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_normol)->child))));
            }
            break;
            case IcePlayer_Play_Mode_Radom: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_radom), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_radom )->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_radom )->child))));
            }
            break;
            case IcePlayer_Play_Mode_One: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_one), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_one)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_one)->child))));
            }
            break;
            case IcePlayer_Play_Mode_Normal_Round: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_normol_round), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_normol_round)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_normol_round)->child))));
            }
            break;
            }
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_normol );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_radom );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_one );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_normol_round );
            g_signal_connect(menu_normol ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_radom ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_one ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_normol_round ,"activate",G_CALLBACK(Play_Type),NULL);

            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup_new(GTK_MENU(menu),3,3);
        }
        return TRUE;
    }
    case 10: {
        if (pipeline) {
            gint w,h;
            gtk_widget_get_size_request((GtkWidget *) eventbox_process_prev,&w,&h);
            GstFormat fmt = GST_FORMAT_TIME;
            gint64 pos;
            gint64 length;
            gst_element_query_position(pipeline, &fmt, &pos);
            gst_element_query_duration(pipeline, &fmt, &length);
            pos = (((gdouble) event->x+5) / (gdouble) w) * (gdouble) length;
            gint64 nanosec = (gdouble) pos/1000000000 * GST_SECOND;
            gst_element_seek(pipeline,1.0,GST_FORMAT_TIME,GST_SEEK_FLAG_FLUSH,GST_SEEK_TYPE_SET,nanosec,GST_SEEK_TYPE_NONE,GST_CLOCK_TIME_NONE);
        }
        return FALSE;
    }
    case 11: {
        if (pipeline) {
            process_timer = FALSE;
            gint x, y;
            gtk_widget_get_size_request(eventbox_process_prev,&x,&y);
            GstFormat fmt = GST_FORMAT_TIME;
            gint64 pos;
            gint64 length;
            gst_element_query_position(pipeline, &fmt, &pos);
            gst_element_query_duration(pipeline, &fmt, &length);
            pos = ((((gdouble) event->x+x-7)*1.02) / (gdouble) 200.0) * (gdouble) length;
            gint64 nanosec = (gdouble) pos/1000000000 * GST_SECOND;
            gst_element_seek(pipeline,1.0,GST_FORMAT_TIME,GST_SEEK_FLAG_FLUSH,GST_SEEK_TYPE_SET,nanosec,GST_SEEK_TYPE_NONE,GST_CLOCK_TIME_NONE);
        }
        return FALSE;
    }
    case 12: {
        volume_timer = FALSE;
        return FALSE;
    }
    }
    return TRUE;
}
gvoid on_tray_activate_event() {
    if (!gtk_window_is_active((GtkWindow *)IcePlayer))view();
    else hide();
}
gvoid on_tray_menu_event(gint type) {
    GtkWidget * traymenu=gtk_menu_new();
    GtkWidget *traymenuItemView=gtk_image_menu_item_new_with_label("顯示");
    GtkWidget *traymenuItemHide=gtk_image_menu_item_new_with_label("隐藏");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemView), gtk_image_new_from_stock ("gtk-fullscreen", GTK_ICON_SIZE_MENU));
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemHide), gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU));
    GtkWidget *menu_separator1 = gtk_separator_menu_item_new ();
    GtkWidget *menu_mode= gtk_image_menu_item_new_with_label("播放模式...");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( menu_mode),gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
    GtkWidget *menu_mode_sub = gtk_menu_new();
    gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_mode), menu_mode_sub);
    GtkWidget *traymenuItem_normol = gtk_image_menu_item_new_with_label("顺序播放");
    GtkWidget *traymenuItem_radom = gtk_image_menu_item_new_with_label("随机播放");
    GtkWidget *traymenuItem_one = gtk_image_menu_item_new_with_label("单曲循环");
    GtkWidget *traymenuItem_normol_round = gtk_image_menu_item_new_with_label("列表循环");
    switch (play_type) {
    case IcePlayer_Play_Mode_Normal: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_normol), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_normol)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_normol)->child))));
    }
    break;
    case IcePlayer_Play_Mode_Radom: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_radom), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_radom )->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_radom )->child))));
    }
    break;
    case IcePlayer_Play_Mode_One: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_one), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_one)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_one)->child))));
    }
    break;
    case IcePlayer_Play_Mode_Normal_Round: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_normol_round), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_normol_round)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_normol_round)->child))));
    }
    break;
    }
    GtkWidget *menu_separator2 = gtk_separator_menu_item_new ();
    GtkWidget * traymenuItemGo;
    if (play_state == IcePlayer_Play_State_PLAYING) {
        traymenuItemGo=gtk_image_menu_item_new_with_label("暂停");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemGo),gtk_image_new_from_stock ("gtk-media-pause", GTK_ICON_SIZE_MENU));
    } else {
        traymenuItemGo=gtk_image_menu_item_new_with_label("播放");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemGo),gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_MENU));
    }
    GtkWidget *traymenuItemNext=gtk_image_menu_item_new_with_label("下首");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemNext),gtk_image_new_from_stock ("gtk-media-next", GTK_ICON_SIZE_MENU));
    GtkWidget *traymenuItemUp=gtk_image_menu_item_new_with_label("上首");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemUp),gtk_image_new_from_stock ("gtk-media-previous", GTK_ICON_SIZE_MENU));
    GtkWidget *traymenuItemStop=gtk_image_menu_item_new_with_label("停止");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemStop),gtk_image_new_from_stock ("gtk-media-stop", GTK_ICON_SIZE_MENU));
    GtkWidget *menu_separator3 = gtk_separator_menu_item_new ();
    GtkWidget *traymenuItemlrc_use_lrc;
    if (!show_lrc)traymenuItemlrc_use_lrc = gtk_image_menu_item_new_with_label("使用歌词");
    else traymenuItemlrc_use_lrc = gtk_image_menu_item_new_with_label("关闭歌词");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemlrc_use_lrc),gtk_image_new_from_stock ("gtk-unindent", GTK_ICON_SIZE_MENU));
    GtkWidget *traymenuItemlrc_change=NULL;
    if (show_lrc) {
        if (save_use_desktop_lrc) traymenuItemlrc_change= gtk_image_menu_item_new_with_label("桌面歌词->窗口歌词");
        else traymenuItemlrc_change = gtk_image_menu_item_new_with_label("窗口歌词->桌面歌词");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemlrc_change),gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU));
    }
    GtkWidget *traymenuItemLrc = NULL ;
    if (show_lrc&&save_use_desktop_lrc) {
        if (save_lrc_no_has_press_event) {
            traymenuItemLrc= gtk_image_menu_item_new_with_label("取消鼠标穿透");
        } else {
            traymenuItemLrc = gtk_image_menu_item_new_with_label("使用鼠标穿透");
        }
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemLrc),gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_MENU));
    }
    GtkWidget *traymenuItemlrc_redownload_file_name = NULL;
    GtkWidget *traymenuItemlrc_redownload_id3 = NULL;
    if (show_lrc) {
        traymenuItemlrc_redownload_file_name = gtk_image_menu_item_new_with_label("搜索歌词(文件名)");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemlrc_redownload_file_name),gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_MENU));
        traymenuItemlrc_redownload_id3 = gtk_image_menu_item_new_with_label("搜索歌词(歌曲标签id3)");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemlrc_redownload_id3),gtk_image_new_from_stock ("gtk-find", GTK_ICON_SIZE_MENU));
    }
    GtkWidget *menu_separator4 = gtk_separator_menu_item_new ();
    GtkWidget *traymenuItemConfig = gtk_image_menu_item_new_with_label("配置");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemConfig),gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU));
    GtkWidget *traymenu_help = gtk_image_menu_item_new_with_label("帮助");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenu_help),gtk_image_new_from_stock ("gtk-help",GTK_ICON_SIZE_MENU));
    GtkWidget *traymenu_update = gtk_image_menu_item_new_with_label("检查更新");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenu_update),gtk_image_new_from_stock ("gtk-refresh",GTK_ICON_SIZE_MENU));
    GtkWidget *traymenuItemAbout = gtk_image_menu_item_new_with_label("关于");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemAbout),gtk_image_new_from_stock ("gtk-about", GTK_ICON_SIZE_MENU));
    GtkWidget * traymenuItemExit=gtk_image_menu_item_new_with_label("退出程式");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemExit), gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_MENU));
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemView);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemHide);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator1);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_mode );
    gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),traymenuItem_normol );
    gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),traymenuItem_radom );
    gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),traymenuItem_one );
    gtk_menu_shell_append(GTK_MENU_SHELL(menu_mode_sub),traymenuItem_normol_round );
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator2);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemGo);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemNext);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemUp);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemStop);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator3);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemlrc_use_lrc);
    if (show_lrc)gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemlrc_change);
    if (show_lrc&&save_use_desktop_lrc)gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemLrc);
    if (show_lrc)gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemlrc_redownload_file_name );
    if (show_lrc)gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemlrc_redownload_id3 );
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator4);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemConfig);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenu_help);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenu_update);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemAbout);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemExit);
    g_signal_connect((gpointer) traymenuItemView ,"activate" ,G_CALLBACK(view),NULL);
    g_signal_connect((gpointer) traymenuItemHide ,"activate" ,G_CALLBACK(hide),NULL);
    g_signal_connect(traymenuItem_normol ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect(traymenuItem_radom ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect(traymenuItem_one ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect(traymenuItem_normol_round ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect((gpointer) traymenuItemGo ,"activate" ,G_CALLBACK(play),NULL);
    g_signal_connect((gpointer) traymenuItemUp ,"activate" ,G_CALLBACK(prev),NULL);
    g_signal_connect((gpointer) traymenuItemNext ,"activate" ,G_CALLBACK(next),NULL);
    g_signal_connect((gpointer) traymenuItemStop ,"activate" ,G_CALLBACK(stop),NULL);
    g_signal_connect((gpointer) traymenuItemlrc_use_lrc,"activate" ,G_CALLBACK(change_use_lrc),NULL);
    if (show_lrc)g_signal_connect((gpointer) traymenuItemlrc_change,"activate" ,G_CALLBACK(change_use_desktop_or_widget),NULL);
    if (show_lrc&&save_use_desktop_lrc)g_signal_connect((gpointer) traymenuItemLrc ,"activate" ,G_CALLBACK(change_desktop_lrc_has_press_event),NULL);
    if (show_lrc)g_signal_connect((gpointer) traymenuItemlrc_redownload_file_name  ,"activate",G_CALLBACK(lrc_redownload),(gpointer)0);
    if (show_lrc)g_signal_connect((gpointer) traymenuItemlrc_redownload_id3  ,"activate",G_CALLBACK(lrc_redownload),(gpointer)1);
    g_signal_connect(traymenuItemConfig,"activate",G_CALLBACK(Config),NULL);
    g_signal_connect(traymenu_help,"activate",G_CALLBACK(Help),NULL);
    g_signal_connect(traymenu_update,"activate",G_CALLBACK(Update),NULL);
    g_signal_connect(traymenuItemAbout,"activate",G_CALLBACK(About),NULL);
    g_signal_connect((gpointer) traymenuItemExit ,"activate" ,G_CALLBACK(quit),NULL);
    gtk_widget_show_all(traymenu);

    if (type != 0) {
        gtk_menu_popup (GTK_MENU(traymenu),NULL,NULL,gtk_status_icon_position_menu,trayIcon,3,gtk_get_current_event_time());
    } else {
        gtk_menu_popup_new(GTK_MENU(traymenu),3,3);
    }
}
gboolean on_IcePlayer_focus_in_event (GtkWidget *IcePlayer,GdkEventButton *event,gpointer user_data) {
    drag_lock=FALSE;
    focus = TRUE;
    save_config();
    return FALSE;
}
gboolean on_IcePlayer_focus_out_event (GtkWidget *IcePlayer,GdkEventButton *event,gpointer user_data) {
    show_iceplayer = FALSE;
    focus = FALSE;
    return FALSE;
}
gboolean on_IcePlayer_key_press_event (GtkWidget *IcePlayer,GdkEventKey *event,gpointer user_data) {

    if (event->type == GDK_KEY_PRESS) {
        if (event->keyval==GDK_Return) {
            stop();
            play();
            view();

        }
        if (event->keyval==GDK_Delete) {
            List_delete((GtkMenuItem*)gtk_image_menu_item_new_with_label("移除选中的文件"), NULL);
        }
        if (event->keyval==GDK_F1) {
            Help();

        }
    }
    return FALSE;
}
gboolean on_IcePlayer_show_event() {
    /**///绑定全局快捷键
    g_print("绑定全局快捷键\n");
    keybinding_init();
    /**///读取配置
    g_print("读取配置\n");
    read_config();
    set_font();
    /**///实现保存音量？
    g_print("实现保存音量？\n");
    set_volume_value(volume*100);
    /**///主循环 进度更新,lrc更新,自动缩进
    g_print("主循环 进度更新,lrc更新,自动缩进\n");
    g_timeout_add(500,(GSourceFunc)update_time,NULL);
    /**///实现保存播放状态
    g_print("实现保存播放状态\n");
    if (GTK_IS_TREE_VIEW(treeview)) {
        GtkTreeSelection  *as =gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
        if (GTK_IS_TREE_SELECTION(as)) {
            GList *list = gtk_tree_selection_get_selected_rows(as,NULL);
            if (save_if_play) {
                if (list) {
                    play_path = (GtkTreePath *) list->data;
                    play();
                }
            } else {
                /**///notify
                NotifyNotification *notify_welcome = notify_notification_new("welcome", "欢迎使用iceplayer", "/usr/share/iceplayer/iceplayer.png", NULL);
                notify_notification_show(notify_welcome, NULL);
            }
        }
    }
    return FALSE;
}
gvoid create_IcePlayer(gvoid) {
    IcePlayer=gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request(IcePlayer,300,3);
    gtk_window_set_decorated(GTK_WINDOW(IcePlayer),FALSE); /*没有边框*/
    gtk_window_resize(GTK_WINDOW(IcePlayer),300,480);
    gtk_window_stick (GTK_WINDOW(IcePlayer));

    GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
    gtk_window_set_icon(GTK_WINDOW(IcePlayer),(GdkPixbuf *)IcePlayer_icon_pixbuf);
    trayIcon=gtk_status_icon_new_from_pixbuf((GdkPixbuf *)IcePlayer_icon_pixbuf);
    gtk_status_icon_set_tooltip(trayIcon,"iceplayer by jasy.ice@163.com");
    gtk_status_icon_set_visible(GTK_STATUS_ICON(trayIcon),TRUE);

    vbox_main=gtk_vbox_new(FALSE,0);
    gtk_widget_show(vbox_main);
    gtk_container_add(GTK_CONTAINER(IcePlayer),vbox_main);

    fixed=gtk_fixed_new();
    gtk_widget_show(fixed);
    gtk_box_pack_start(GTK_BOX(vbox_main),fixed,FALSE,FALSE,0);
    gtk_widget_set_size_request(fixed,0,128);

    eventbox_main=gtk_event_box_new();
    gtk_widget_show(eventbox_main);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_main,0,-1);
    gtk_widget_set_size_request(eventbox_main,300,130);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_main,FALSE);

    image_main=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_main,TRUE,NULL));
    gtk_widget_show(image_main);
    gtk_container_add(GTK_CONTAINER(eventbox_main),image_main);
    gtk_widget_set_size_request(image_main,300,130);

    eventbox_prev=gtk_event_box_new();
    gtk_widget_show(eventbox_prev);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_prev,12,40);
    gtk_widget_set_size_request(eventbox_prev,20,20);

    image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev,TRUE,NULL));
    gtk_widget_show(image_prev);
    gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
    gtk_widget_set_size_request(image_prev,20,20);

    eventbox_play=gtk_event_box_new();
    gtk_widget_show(eventbox_play);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_play,38,40);
    gtk_widget_set_size_request(eventbox_play,20,20);

    image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
    gtk_widget_show(image_play);
    gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
    gtk_widget_set_size_request(image_play,20,20);

    eventbox_next=gtk_event_box_new();
    gtk_widget_show(eventbox_next);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_next,12+26*2,40);
    gtk_widget_set_size_request(eventbox_next,20,20);

    image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next,TRUE,NULL));
    gtk_widget_show(image_next);
    gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
    gtk_widget_set_size_request(image_next,20,20);

    eventbox_stop=gtk_event_box_new();
    gtk_widget_show(eventbox_stop);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_stop,12+26*3,40);
    gtk_widget_set_size_request(eventbox_stop,20,20);

    image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop,TRUE,NULL));
    gtk_widget_show(image_stop);
    gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
    gtk_widget_set_size_request(image_stop,20,20);

    hbox_process = gtk_hbox_new (FALSE, 0);
    gtk_widget_show (hbox_process);
    gtk_fixed_put (GTK_FIXED (fixed), hbox_process, 12, 110);
    gtk_widget_set_size_request (hbox_process, 200, 12);

    eventbox_process_prev = gtk_event_box_new ();
    gtk_widget_show (eventbox_process_prev);
    gtk_box_pack_start (GTK_BOX (hbox_process), eventbox_process_prev, TRUE, TRUE, 0);
    gtk_widget_set_size_request (eventbox_process_prev,14, 12);

    image_process_prev = gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_prev,TRUE,NULL));
    gtk_widget_show (image_process_prev);
    gtk_container_add (GTK_CONTAINER (eventbox_process_prev), image_process_prev);

    eventbox_process_node = gtk_event_box_new ();
    gtk_widget_show (eventbox_process_node);
    gtk_box_pack_start (GTK_BOX (hbox_process), eventbox_process_node, FALSE, FALSE, 0);

    image_process_node =gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_node,TRUE,NULL));
    gtk_widget_show (image_process_node);
    gtk_container_add (GTK_CONTAINER (eventbox_process_node), image_process_node);

    eventbox_process_next = gtk_event_box_new ();
    gtk_widget_show (eventbox_process_next);
    gtk_box_pack_start (GTK_BOX (hbox_process), eventbox_process_next, TRUE, TRUE, 0);

    image_process_next = gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_next,TRUE,NULL));
    gtk_widget_show (image_process_next);
    gtk_container_add (GTK_CONTAINER (eventbox_process_next), image_process_next);
    gtk_widget_set_size_request (eventbox_process_prev,7,12);
    gtk_widget_set_size_request (eventbox_process_next,193,12);

    hbox_volume = gtk_hbox_new (FALSE, 0);
    gtk_widget_show (hbox_volume);
    gtk_fixed_put (GTK_FIXED (fixed), hbox_volume, 220, 110);
    gtk_widget_set_size_request (hbox_volume, 70, 12);

    eventbox_volume_prev = gtk_event_box_new ();
    gtk_widget_show (eventbox_volume_prev);
    gtk_box_pack_start (GTK_BOX (hbox_volume), eventbox_volume_prev, TRUE, TRUE, 0);

    image_volume_prev = gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_prev,TRUE,NULL));
    gtk_widget_show (image_volume_prev);
    gtk_container_add (GTK_CONTAINER (eventbox_volume_prev), image_volume_prev);

    eventbox_volume_node = gtk_event_box_new ();
    gtk_widget_show (eventbox_volume_node);
    gtk_box_pack_start (GTK_BOX (hbox_volume), eventbox_volume_node, FALSE, FALSE, 0);

    image_volume_node =gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_node,TRUE,NULL));
    gtk_widget_show (image_volume_node);
    gtk_container_add (GTK_CONTAINER (eventbox_volume_node), image_volume_node);

    eventbox_volume_next = gtk_event_box_new ();
    gtk_widget_show (eventbox_volume_next);
    gtk_box_pack_start (GTK_BOX (hbox_volume), eventbox_volume_next, TRUE, TRUE, 0);

    image_volume_next = gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_hscale_next,TRUE,NULL));
    gtk_widget_show (image_volume_next);
    gtk_container_add (GTK_CONTAINER (eventbox_volume_next), image_volume_next);

    label_info=gtk_label_new("");
    gtk_widget_show(label_info);
    gtk_fixed_put(GTK_FIXED(fixed),label_info,13,58);
    gtk_widget_set_size_request(label_info,275,35);
    gtk_label_set_use_markup(GTK_LABEL(label_info),TRUE);
    gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                            ");

    label_info2=gtk_label_new("");
    gtk_widget_show(label_info2);
    gtk_fixed_put(GTK_FIXED(fixed),label_info2,13,82);
    gtk_widget_set_size_request(label_info2,200,35);
    gtk_label_set_use_markup(GTK_LABEL(label_info2),TRUE);
    gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");

    label_info3=gtk_label_new("");
    gtk_widget_show(label_info3);
    gtk_fixed_put(GTK_FIXED(fixed),label_info3,220,85);
    gtk_widget_set_size_request(label_info3,-1,35);
    gtk_label_set_justify(GTK_LABEL(label_info3),GTK_JUSTIFY_LEFT);
    gtk_label_set_use_markup(GTK_LABEL(label_info3),TRUE);
    gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");

    gchar _[]={10,9,-30,-107,-78,-30,-128,-106,-30,-107,-79,32,10,9,8,40,94,95,94,41,10,32,32,32,32,-30,-120,-117,-30,-128,-108,45,-30,-105,-91,-30,-107,-108,61,-30,-107,-105,-30,-105,-92,45,-30,-128,-108,-30,-120,-120,10,9,-30,-107,-102,61,-30,-107,-99,10,9,8,-30,-107,-79,32,32,32,-30,-107,-78,10,32,32,32,32,32,-30,-105,-94,-30,-105,-92,32,32,32,32,32,-30,-105,-91,-30,-105,-93,10,10};
    hbox_list=gtk_hbox_new(FALSE,0);
    gtk_widget_show(hbox_list);
    gtk_box_pack_start(GTK_BOX(vbox_main),hbox_list,TRUE,TRUE,0);
    image_list_left=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_list_left,TRUE,NULL));
    gtk_widget_show(image_list_left);
    gtk_box_pack_start(GTK_BOX(hbox_list),image_list_left,FALSE,FALSE,0);
    gtk_widget_set_size_request(image_list_left,13,50);

    scrolledwindow=gtk_scrolled_window_new(NULL,NULL);
    gtk_widget_show(scrolledwindow);
    gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow),GTK_SHADOW_NONE);
    gtk_box_pack_start(GTK_BOX(hbox_list),scrolledwindow,TRUE,TRUE,0);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);

    treeview=gtk_tree_view_new();
    gtk_widget_show(treeview);
    gtk_container_add(GTK_CONTAINER(scrolledwindow),treeview);
    gtk_tree_view_set_reorderable(GTK_TREE_VIEW(treeview), TRUE);
    gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(treeview), FALSE);
    init_list(treeview);
    gtk_tree_view_column_set_min_width  (gtk_tree_view_get_column((GtkTreeView *)treeview,1),400);

    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    gtk_tree_selection_set_mode(selection,GTK_SELECTION_MULTIPLE);
//文件拖放
    set_drag();

    image_list_right=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_list_right,TRUE,NULL));
    gtk_widget_show(image_list_right);
    gtk_box_pack_start(GTK_BOX(hbox_list),image_list_right,FALSE,FALSE,0);
    gtk_widget_set_size_request(image_list_right,10,50);

    fixed_list=gtk_fixed_new();
    gtk_widget_show(fixed_list);
    gtk_box_pack_start(GTK_BOX(vbox_main),fixed_list,FALSE,FALSE,0);

    eventbox_list_down=gtk_event_box_new();
    gtk_widget_show(eventbox_list_down);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_list_down,-1,0);
    gtk_widget_set_size_request(eventbox_list_down,302,30);
    g_print("%s",_);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_list_down,FALSE); /*不让eventbox覆盖其他控件*/

    image_list_down=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_list_down,TRUE,NULL));
    gtk_widget_show(image_list_down);
    gtk_container_add(GTK_CONTAINER(eventbox_list_down),image_list_down);
    gtk_widget_set_size_request(image_list_down,302,30);

    eventbox_tools_add=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_add);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_add,45,5);
    gtk_widget_set_size_request(eventbox_tools_add,50,21);

    image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add,TRUE,NULL));
    gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
    gtk_widget_show(image_tools_add);
    gtk_widget_set_size_request(image_tools_add,50,21);

    eventbox_tools_dele=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_dele);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_dele,100,5);
    gtk_widget_set_size_request(eventbox_tools_dele,50,21);

    image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele,TRUE,NULL));
    gtk_widget_show(image_tools_dele);
    gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
    gtk_widget_set_size_request(image_tools_dele,50,21);

    eventbox_tools_list=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_list);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_list,155,5);
    gtk_widget_set_size_request(eventbox_tools_list,50,21);

    image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list,TRUE,NULL));
    gtk_widget_show(image_tools_list);
    gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
    gtk_widget_set_size_request(image_tools_list,50,21);

    eventbox_tools_mode=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_mode);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_mode,210,5);
    gtk_widget_set_size_request(eventbox_tools_mode,50,21);

    image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode,TRUE,NULL));
    gtk_widget_show(image_tools_mode);
    gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
    gtk_widget_set_size_request(image_tools_mode,50,21);

    eventbox_min=gtk_event_box_new();
    gtk_widget_show(eventbox_min);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_min,242,7);
    gtk_widget_set_size_request(eventbox_min,20,19);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_min,FALSE);

    image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min,TRUE,NULL));
    gtk_widget_show(image_min);
    gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
    gtk_widget_set_size_request(image_min,20,19);

    eventbox_close=gtk_event_box_new();
    gtk_widget_show(eventbox_close);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_close,273,7);
    gtk_widget_set_size_request(eventbox_close,20,19);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_close,FALSE);

    image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close,TRUE,NULL));
    gtk_widget_show(image_close);
    gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
    gtk_widget_set_size_request(image_close,20,19);

    eventbox_left_top=gtk_event_box_new();
    gtk_widget_show(eventbox_left_top);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_left_top,-1,-1);
    gtk_widget_set_size_request(eventbox_left_top,25,20);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_left_top,FALSE);

    eventbox_right_down=gtk_event_box_new();
    gtk_widget_show(eventbox_right_down);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_right_down,271,0);
    gtk_widget_set_size_request(eventbox_right_down,30,30);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_right_down,FALSE);

    eventbox_left_down=gtk_event_box_new();
    gtk_widget_show(eventbox_left_down);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_left_down,-1,0);
    gtk_widget_set_size_request(eventbox_left_down,30,30);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_left_down,FALSE);

    g_signal_connect((gpointer) IcePlayer            ,"delete_event"        ,G_CALLBACK(quit),NULL);
    g_signal_connect((gpointer) IcePlayer            ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )13);
    g_signal_connect((gpointer) IcePlayer            ,"focus_in_event"      ,G_CALLBACK(on_IcePlayer_focus_in_event),NULL);
    g_signal_connect((gpointer) IcePlayer            ,"focus_out_event"     ,G_CALLBACK(on_IcePlayer_focus_out_event),NULL);
    g_signal_connect((gpointer) IcePlayer            ,"key_press_event"     ,G_CALLBACK(on_IcePlayer_key_press_event),NULL);
    g_signal_connect((gpointer) trayIcon             ,"activate"            ,G_CALLBACK(on_tray_activate_event), NULL);
    g_signal_connect((gpointer) trayIcon             ,"popup-menu"          ,G_CALLBACK(on_tray_menu_event),NULL);
    g_signal_connect((gpointer) eventbox_play        ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_play        ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_play        ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_play        ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_prev        ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_prev        ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_prev        ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_prev        ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_next        ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_next        ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_next        ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_next        ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_stop        ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_stop        ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_stop        ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_stop        ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_min         ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_min         ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_min         ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_min         ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_close       ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_close       ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_close       ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )6);
    g_signal_connect((gpointer) eventbox_close       ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )6);
    g_signal_connect((gpointer) treeview             ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )14);
    g_signal_connect((gpointer) treeview             ,"button_release_event",G_CALLBACK(on_press_event),(gpointer )14);
    g_signal_connect((gpointer) treeview             ,"key_press_event"     ,G_CALLBACK(on_list_key_press_event),NULL);
    g_signal_connect((gpointer) treeview             ,"drag_end"            ,G_CALLBACK(on_treeview_drag_drop),NULL);
    g_signal_connect((gpointer) treeview             ,"drag_data_received"  ,G_CALLBACK(on_treeview_drag_data_received),NULL);
    g_signal_connect((gpointer) eventbox_tools_add   ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )6);
    g_signal_connect((gpointer) eventbox_tools_add   ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_add   ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )6);
    g_signal_connect((gpointer) eventbox_tools_add   ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_dele  ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_dele  ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_dele  ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_dele  ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_list  ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_list  ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_list  ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_list  ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_mode  ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_mode  ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )10);
    g_signal_connect((gpointer) eventbox_tools_mode  ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_mode  ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )10);
    g_signal_connect((gpointer) eventbox_right_down  ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )10);
    g_signal_connect((gpointer) eventbox_left_top    ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )11);
    g_signal_connect((gpointer) eventbox_left_down   ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )12);
    g_signal_connect((gpointer) eventbox_left_down   ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_left_down   ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_right_down  ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_right_down  ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_left_top    ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_left_top    ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_process_prev,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )15);
    g_signal_connect((gpointer) eventbox_process_node,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )16);
    g_signal_connect((gpointer) eventbox_process_node,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )12);
    g_signal_connect((gpointer) eventbox_process_node,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )12);
    g_signal_connect((gpointer) eventbox_process_node,"button_release_event",G_CALLBACK(on_release_event),(gpointer )11);
    g_signal_connect((gpointer) eventbox_process_next,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )17);
    g_signal_connect((gpointer) eventbox_volume_prev ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )18);
    g_signal_connect((gpointer) eventbox_volume_node ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )19);
    g_signal_connect((gpointer) eventbox_volume_node ,"enter-notify-event"  ,G_CALLBACK(on_enter_event),(gpointer )13);
    g_signal_connect((gpointer) eventbox_volume_node ,"leave-notify-event"  ,G_CALLBACK(on_leave_event),(gpointer )13);
    g_signal_connect((gpointer) eventbox_volume_node ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )12);
    g_signal_connect((gpointer) eventbox_volume_next ,"button_press_event"  ,G_CALLBACK(on_press_event),(gpointer )20);
}
gint main(gint argc,gchar *argv[]) {
    /**///init初始化
    gtk_init(&argc,&argv);
    gst_init(&argc,&argv);
    notify_init("IcePlayer");
    /**///定义基本变量
    g_print("定义基本变量\n");
    strcpy(version,"3.07");
    strcpy(list_file_path,g_get_home_dir());
    strcat(list_file_path,"/.IcePlayer/filelist");
    strcpy(config_file_path,g_get_home_dir());
    strcat(config_file_path,"/.IcePlayer/config.");
    strcat(config_file_path,version);
    strcpy(tmp_file_path,g_get_tmp_dir());
    strcat(tmp_file_path,"/IcePlayer.log");
    /**///生成目录
    g_print("生成目录\n");
    gchar make_config_dir[200];
    strcpy(make_config_dir,"mkdir --parents ");
    strcat(make_config_dir,g_get_home_dir());
    strcat(make_config_dir,"/.IcePlayer");
    if (system(make_config_dir));
    /**///单实例限制
    g_print("单实例限制\n");
    //if (system("rm -rf /tmp/iceplayer*"));
    BaconMessageConnection *message_conn;
    gchar *connection_name = "iceplayer";
    message_conn = bacon_message_connection_new (connection_name);
    if (!bacon_message_connection_get_is_server (message_conn)) {
        bacon_message_connection_send (message_conn, "raise");

        gboolean has_other_instance = FALSE;
        if (system("ps -C iceplayer > /tmp/IcePlayer.log"));
        FILE *file = fopen(tmp_file_path,"a+");
        gchar nnm[2000];
        if (fgets(nnm,2000,file)) {
            if (fgets(nnm,2000,file)) {
                if (fgets(nnm,2000,file)) {
                    has_other_instance = TRUE;
                } else {
                    has_other_instance = FALSE;//只有一个实例
                }
            }
        }
        fclose(file);
        unlink(tmp_file_path);

        g_print("\nATTENTION!\niceplayer 检测到有其他iceplayer进程在运行，正常情况下我会尝试将另一个iceplayer窗口显示出来，失败？首先请确认没有其他iceplayer进程在运行，再将/tmp/下的所有 iceplayer 开头的文件删除,祝你使用愉快。\n");
        if (has_other_instance) {
            return 0;
        } else {
            g_print("? 没有其他的iceplayer ？\n");
            if (system("rm -rf /tmp/iceplayer*"));
        }
    }
    /**///主窗体创建
    g_print("主窗体创建\n");
    create_IcePlayer();
    /**///绑定单实例限制回应函数
    g_print("绑定单实例限制回应函数\n");
    bacon_message_connection_set_callback (message_conn,(BaconMessageReceivedFunc) view,IcePlayer);
    /**///gtk_main之后进行读取并应用配置
    g_timeout_add(50,(GSourceFunc)on_IcePlayer_show_event,NULL);
    /**///主循环
    g_print("主循环\n");
    gtk_main ();

    return 0;
}
