/**//*   配置   */
#include "lrc.h"
static gvoid close_config_dialog(GtkWidget *widget ) {
    show_config_dialog = FALSE;
    save_config();
    gtk_widget_destroy(config_dialog);
    show_iceplayer = FALSE;
}
static gboolean on_fontbutton_font_set(GtkFontButton *fontbutton,gint  type) {
    PangoFontDescription *pfd;
    pfd = pango_font_description_from_string(gtk_font_button_get_font_name(fontbutton));
    switch (type) {
    case 1: {
        strcpy(font_treeview,gtk_font_button_get_font_name(fontbutton));
        if (GTK_IS_WIDGET(treeview))gtk_widget_modify_font(GTK_WIDGET(treeview),pfd);
        break;
    }
    case 2: {
        strcpy(font_info1,gtk_font_button_get_font_name(fontbutton));
        if (GTK_IS_WIDGET(label_info))gtk_widget_modify_font(GTK_WIDGET(label_info),pfd);
        break;
    }
    case 3: {
        strcpy(font_info2,gtk_font_button_get_font_name(fontbutton));
        if (GTK_IS_WIDGET(label_info2))gtk_widget_modify_font(GTK_WIDGET(label_info2),pfd);
        break;
    }
    case 4 : {
        strcpy(font_info3,gtk_font_button_get_font_name(fontbutton));
        if (GTK_IS_WIDGET(label_info3))gtk_widget_modify_font(GTK_WIDGET(label_info3),pfd);
        break;
    }
    case 5 : {
        if (save_use_desktop_lrc) {
            strcpy(font_desktop_lrc,gtk_font_button_get_font_name(fontbutton));
            if (GTK_IS_WIDGET(desktop_lrc_label))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label),pfd);
            if (GTK_IS_WIDGET(desktop_lrc_label2))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label2),pfd);
            if (GTK_IS_WIDGET(desktop_lrc_label3))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label3),pfd);
            if (GTK_IS_WINDOW(desktop_lrc_window))  gtk_window_resize((GtkWindow   *)desktop_lrc_window,1,1);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, pfd);
            if (GTK_IS_WIDGET(config_label8))gtk_widget_modify_font (config_label8, pfd);
            break;
        } else {
            strcpy(font_widget_lrc,gtk_font_button_get_font_name(fontbutton));
            if (GTK_IS_WIDGET(widget_lrc_label))gtk_widget_modify_font(GTK_WIDGET(widget_lrc_label),pfd);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, pfd);
            if (GTK_IS_WIDGET(config_label8))gtk_widget_modify_font (config_label8, pfd);
            goto_line();
            break;
        }
        if (save_use_desktop_lrc) {
            close_desktop_lrc();
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_use_desktop_lrc)->button),"当前状态:使用桌面歌词");
            gtk_fixed_move (GTK_FIXED (fixed), config_label1, 365, 147);
            gtk_fixed_move (GTK_FIXED (fixed), config_label8, 364, 146);
            gtk_label_set_text((GtkLabel *) config_label9,"桌面歌词示例：");
            gtk_label_set_text((GtkLabel *) config_label10,"桌面歌词字体：");
            gtk_label_set_text((GtkLabel *) config_label11,"桌面歌词颜色：");
            gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_back));
            gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_front));
            PangoFontDescription *font_desc = pango_font_description_from_string(font_desktop_lrc);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
            if (GTK_IS_WIDGET(config_label8))gtk_widget_modify_font (config_label8, font_desc);
            pango_font_description_free (font_desc);
            desktop_lrc_run();
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_front));
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_back));

            break;
        } else {
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_use_desktop_lrc)->button),"当前状态:使用窗口歌词");
            gtk_fixed_move (GTK_FIXED (fixed), config_label1, 365, 107);

            PangoFontDescription *font_desc = pango_font_description_from_string(font_widget_lrc);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
            pango_font_description_free (font_desc);
            gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>菊花台</span>\n<span  foreground='#%s'>满地伤</span>\n<span  foreground='#%s'>你的笑容..</span>",widget_lrc_color_front,widget_lrc_color_back,widget_lrc_color_front));
            gtk_label_set_text((GtkLabel *) config_label8,"");
            gtk_label_set_text((GtkLabel *) config_label9,"窗口歌词示例：");
            gtk_label_set_text((GtkLabel *) config_label10,"窗口歌词字体：");
            gtk_label_set_text((GtkLabel *) config_label11,"窗口歌词颜色：");

            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_front));
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_back));

            goto_line();
            break;
            //abc
        }
    }
    }
    pango_font_description_free(pfd);
    return FALSE;
}
gvoid set_font() {
    PangoFontDescription *pfd;
    pfd = pango_font_description_from_string(font_treeview);
    if (GTK_IS_WIDGET(treeview))gtk_widget_modify_font(GTK_WIDGET(treeview),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_info1);
    if (GTK_IS_WIDGET(label_info))gtk_widget_modify_font(GTK_WIDGET(label_info),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_info2);
    if (GTK_IS_WIDGET(label_info2))gtk_widget_modify_font(GTK_WIDGET(label_info2),pfd);
    pango_font_description_free(pfd);
    pfd = pango_font_description_from_string(font_info3);
    if (GTK_IS_WIDGET(label_info3))gtk_widget_modify_font(GTK_WIDGET(label_info3),pfd);
    pango_font_description_free(pfd);
    if (save_use_desktop_lrc) {
        pfd = pango_font_description_from_string(font_desktop_lrc);
        if (GTK_IS_WIDGET(desktop_lrc_label))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label),pfd);
        if (GTK_IS_WIDGET(desktop_lrc_label2))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label2),pfd);
        if (GTK_IS_WINDOW(desktop_lrc_window)) gtk_window_resize((GtkWindow   *)desktop_lrc_window,1,1);
        pango_font_description_free(pfd);
    } else {
        pfd = pango_font_description_from_string(font_widget_lrc);
        if (GTK_IS_WIDGET(widget_lrc_label))gtk_widget_modify_font(GTK_WIDGET(widget_lrc_label),pfd);
        pango_font_description_free(pfd);
    }
}
static gvoid on_checkbutton_toggled(GtkToggleButton *togglebutton,gint type) {
    switch (type) {
    case 2: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_volume)) {
            save_volume=TRUE;
        } else {
            save_volume=FALSE;
        }
        break;
    }
    case 3: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_tools)) {
            gtk_widget_set_size_request(fixed_list,300,30);
            gtk_widget_show(eventbox_tools_add);
            gtk_widget_show(eventbox_tools_dele);
            gtk_widget_show(eventbox_tools_list);
            gtk_widget_show(eventbox_tools_mode);
            show_tools=TRUE;
        } else {
            gtk_widget_set_size_request(fixed_list,300,11);
            gtk_widget_hide(eventbox_tools_add);
            gtk_widget_hide(eventbox_tools_dele);
            gtk_widget_hide(eventbox_tools_list);
            gtk_widget_hide(eventbox_tools_mode);
            show_tools=FALSE;
        }
        break;
    }
    case 4: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_file)) {
            save_file=TRUE;
        } else {
            save_file=FALSE;
        }
        break;
    }
    case  5: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_pos_size)) {
            save_pos_size=TRUE;
        } else {
            save_pos_size=FALSE;
        }
        break;
    }
    case  6: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_file_playing)) {
            save_file_playing=TRUE;
        } else {
            save_file_playing=FALSE;
        }
        break;
    }
    case 7: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_if_play)) {
            save_if_play=TRUE;
        } else {
            save_if_play = FALSE;
        }
        break;
    }
    case 8: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_play_mode)) {
            save_play_mode=TRUE;
        } else {
            save_play_mode = FALSE;
        }
        break;
    }
    case 9: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_notify)) {
            show_notify=TRUE;
        } else {
            show_notify = FALSE;
        }
        break;
    }
    case 10: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_min)) {
            show_min=TRUE;
        } else {
            show_min = FALSE;
        }
        break;
    }
    case 11: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_show_lrc)) {
            show_lrc=TRUE;
        } else {
            show_lrc = FALSE;
            save_download_lrc = FALSE;
            gtk_toggle_button_set_active       ( (GtkToggleButton *)checkbutton_save_download_lrc,FALSE);
        }
        close_desktop_lrc();
        break;
    }
    case 12: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_lrc_no_has_press_event)) {
            save_lrc_no_has_press_event=TRUE;
        } else {
            save_lrc_no_has_press_event = FALSE;
        }
        //close_desktop_lrc();
        if (show_lrc)desktop_lrc_show("09");//不要怀疑,是的，他就是09,不要疑惑，是的，他还是09. 为什么不是10?  2010多好啊，～_～要求那么高，自己改去。
        break;
    }
    case 13: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_download_lrc)) {
            save_download_lrc=TRUE;
            gtk_toggle_button_set_active       ( (GtkToggleButton *)checkbutton_show_lrc,TRUE);
            show_lrc=TRUE;
        } else {
            save_download_lrc = FALSE;
        }
        break;
    }
    case 14: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_download_lrc_path)) {
            save_download_lrc_path=TRUE;
            gtk_widget_set_sensitive (config_entry_download_lrc_path,FALSE);
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_download_lrc_path)->button),"当前状态:下载歌词到歌曲所在目录");

        } else {
            save_download_lrc_path = FALSE;
            gtk_widget_set_sensitive (config_entry_download_lrc_path,TRUE);
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_download_lrc_path)->button),"当前状态:下载歌词到指定目录");
        }
        break;
    }
    case 15: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_desktop_lrc_back_png)) {
            save_desktop_lrc_back_png=TRUE;
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,TRUE);
        } else {
            save_desktop_lrc_back_png = FALSE;
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,FALSE);
        }
        if (show_lrc)desktop_lrc_show("09");
        break;
    }
    case 16: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_use_desktop_lrc)) {
            save_use_desktop_lrc=TRUE;
        } else {
            save_use_desktop_lrc = FALSE;
        }
        if (save_use_desktop_lrc) {
            close_desktop_lrc();

            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_use_desktop_lrc)->button),"当前状态:使用桌面歌词");
            gtk_fixed_move (GTK_FIXED (fixed), config_label1, 365, 147);
            gtk_fixed_move (GTK_FIXED (fixed), config_label8, 364, 146);
            gtk_label_set_text((GtkLabel *) config_label9,"桌面歌词示例：");
            gtk_label_set_text((GtkLabel *) config_label10,"桌面歌词字体：");
            gtk_label_set_text((GtkLabel *) config_label11,"桌面歌词颜色：");
            gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_back));
            gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_front));
            PangoFontDescription *font_desc = pango_font_description_from_string(font_desktop_lrc);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
            if (GTK_IS_WIDGET(config_label8))gtk_widget_modify_font (config_label8, font_desc);
            pango_font_description_free (font_desc);

            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_front));
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_back));
            gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,font_desktop_lrc);
            switch (desktop_lrc_justify) {
            case GTK_JUSTIFY_LEFT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"桌面歌词对齐：左对齐");
                break;
            }
            desktop_lrc_run();
            break;
        } else {
            gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,font_widget_lrc);
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_use_desktop_lrc)->button),"当前状态:使用窗口歌词");
            gtk_fixed_move (GTK_FIXED (fixed), config_label1, 365, 107);

            PangoFontDescription *font_desc = pango_font_description_from_string(font_widget_lrc);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
            pango_font_description_free (font_desc);
            gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>菊花台</span>\n<span  foreground='#%s'>满地伤</span>\n<span  foreground='#%s'>你的笑容..</span>",widget_lrc_color_front,widget_lrc_color_back,widget_lrc_color_front));
            gtk_label_set_text((GtkLabel *) config_label8,"");
            gtk_label_set_text((GtkLabel *) config_label9,"窗口歌词示例：");
            gtk_label_set_text((GtkLabel *) config_label10,"窗口歌词字体：");
            gtk_label_set_text((GtkLabel *) config_label11,"窗口歌词颜色：");
            widget_lrc_run();

            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_front));
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_back));

            switch (widget_lrc_justify) {
            case GTK_JUSTIFY_LEFT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：左对齐");
                break;
            case GTK_JUSTIFY_RIGHT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：右对齐");
                break;
            case GTK_JUSTIFY_CENTER:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：居中");
                break;
            }

            break;
        }
    }
    case 17: {
        if (gtk_toggle_button_get_active       ( (GtkToggleButton *)checkbutton_save_widget_lrc_keep_above)) {
            save_widget_lrc_keep_above = TRUE;
        } else {
            save_widget_lrc_keep_above = FALSE;
        }
        if (GTK_IS_WINDOW(widget_lrc_window))gtk_window_set_keep_above (GTK_WINDOW (widget_lrc_window),save_widget_lrc_keep_above);
        break;
    }
    }
}
static gvoid on_reset_button_clicked(GtkWidget *widget,gpointer user_data) {
    GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"是否确认将所有设置返回默认？");
    if (gtk_dialog_run((GtkDialog *) dialog_real) !=-5) {
        gtk_widget_destroy(dialog_real);
        return ;
    }
    gtk_widget_destroy(dialog_real);
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_treeview,"sans 8");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info1,"sans 9");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info2,"sans 8");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info3,"sans 7");
    gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,"sans 32");
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_treeview,1);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_info1,2);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_info2,3);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_info3,4);
    on_fontbutton_font_set ((GtkFontButton   *)fontbutton_lrc,5);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file_playing),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_if_play),FALSE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_play_mode), TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_notify),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_min),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_lrc),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_lrc_no_has_press_event),FALSE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc_path),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_use_desktop_lrc),TRUE);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_desktop_lrc_back_png),FALSE);
    unlink(config_file_path);
    FILE * fileconfig = fopen(config_file_path,"a+");
    fputs(reset_config,fileconfig);
    if (fileconfig) {
        fclose(fileconfig);
        fileconfig=0;
    }
    strcpy(desktop_lrc_color_front,"B19356");
    strcpy(desktop_lrc_color_back,"000000");
    strcpy(widget_lrc_color_front,"5A2EC6");
    strcpy(widget_lrc_color_back,"5BA000");
    strcpy(font_desktop_lrc,"sans 32");
    strcpy(font_widget_lrc,"sans 16");
    strcpy(font_treeview,"sans 8");
    strcpy(font_info1,"sans 9");
    strcpy(font_info2,"sans 8");
    strcpy(font_info3,"sans 7");

    widget_lrc_justify = GTK_JUSTIFY_RIGHT;
    desktop_lrc_justify =GTK_JUSTIFY_CENTER;

    gtk_fixed_move (GTK_FIXED (fixed), config_label1, 335, 177);
    gtk_fixed_move (GTK_FIXED (fixed), config_label8, 334, 176);

    gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_back));
    gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_front));

    PangoFontDescription *font_desc = pango_font_description_from_string(font_desktop_lrc);
    if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
    if (GTK_IS_WIDGET(config_label8))gtk_widget_modify_font (config_label8, font_desc);
    pango_font_description_free (font_desc);

    gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_front));
    gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_back));
    desktop_lrc_x = 0;
    desktop_lrc_y= 0;
    widget_lrc_x = 166;
    widget_lrc_y = 172;
    widget_lrc_width = 368;
    widget_lrc_heigth = 447;
}
static gvoid Justify(GtkMenuItem *item, gpointer user_data) {
    const gchar *title = gtk_label_get_label((GtkLabel  *)GTK_BIN (item)->child);
    if (save_use_desktop_lrc) {
        if (!strcmp(title,"单行")) {
            desktop_lrc_justify = GTK_JUSTIFY_LEFT;
        }
        if (!strcmp(title,"双行")) {
            desktop_lrc_justify = GTK_JUSTIFY_RIGHT;
        }

        switch (desktop_lrc_justify) {
        case GTK_JUSTIFY_LEFT:
            gtk_button_set_label((GtkButton *)config_button_lrc_justify,"桌面歌词行数：单行");
            break;
        case GTK_JUSTIFY_RIGHT:
            gtk_button_set_label((GtkButton *)config_button_lrc_justify,"桌面歌词行数：双行");
            break;
        }
        desktop_lrc_run();
    } else {
        if (!strcmp(title,"左对齐")) {
            widget_lrc_justify = GTK_JUSTIFY_LEFT;
        }
        if (!strcmp(title,"右对齐")) {
            widget_lrc_justify = GTK_JUSTIFY_RIGHT;
        }
        if (!strcmp(title,"居中")) {
            widget_lrc_justify = GTK_JUSTIFY_CENTER;
        }
        switch (widget_lrc_justify) {
        case GTK_JUSTIFY_LEFT:
            gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：左对齐");
            break;
        case GTK_JUSTIFY_RIGHT:
            gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：右对齐");
            break;
        case GTK_JUSTIFY_CENTER:
            gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：居中");
            break;
        }
        if (GTK_IS_WIDGET(widget_lrc_label))gtk_label_set_justify (GTK_LABEL (widget_lrc_label), widget_lrc_justify);
    }
}
static gvoid on_justify_button_clicked(GtkWidget *widget,gpointer user_data) {
    GtkWidget * menu = gtk_menu_new();
    GtkWidget *menu_left=NULL;
    GtkWidget *menu_right=NULL;
    GtkWidget *menu_center=NULL;
    if (!save_use_desktop_lrc) {
        menu_left = gtk_image_menu_item_new_with_label("左对齐");
        menu_right = gtk_image_menu_item_new_with_label("右对齐");
        menu_center = gtk_image_menu_item_new_with_label("居中");
    } else {
        menu_left = gtk_image_menu_item_new_with_label("单行");
        menu_right = gtk_image_menu_item_new_with_label("双行");
    }
    gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_left);
    gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_right);
    if (!save_use_desktop_lrc) {
        gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_center);
    }

    g_signal_connect(menu_left,"activate",G_CALLBACK(Justify),NULL);
    g_signal_connect(menu_right,"activate",G_CALLBACK(Justify),NULL);
    if (!save_use_desktop_lrc) {
        g_signal_connect(menu_center,"activate",G_CALLBACK(Justify),NULL);
    }

    gtk_widget_show_all(menu);

    gtk_menu_popup_new(GTK_MENU(menu),1,1);
}
static gvoid set_color(GtkButton *button,gint type) {
    if (type == 0) {
        gtk_window_set_keep_above     (GTK_WINDOW (config_dialog),TRUE);
        gtk_widget_destroy(colorselectiondialog);
        return ;
    }
    gdouble color[3];
    GdkColor gdk_color;
    gchar x_color[200];
    gchar x_color_red[200];
    gchar x_color_green[200];
    gchar x_color_blue[200];

    gtk_color_selection_get_color ( (GtkColorSelection*)(((GtkColorSelectionDialog *)colorselectiondialog)->colorsel),color);
    if (type==1||type-100 ==1) {
        if (save_use_desktop_lrc) {
            desktop_lrc_front_color_double[0]=color[0];
            desktop_lrc_front_color_double[1]=color[1];
            desktop_lrc_front_color_double[2]=color[2];
        } else {
            widget_lrc_front_color_double[0]=color[0];
            widget_lrc_front_color_double[1]=color[1];
            widget_lrc_front_color_double[2]=color[2];
        }

    }
    if (type==2||type-100 ==2) {
        if (save_use_desktop_lrc) {
            desktop_lrc_back_color_double[0]=color[0];
            desktop_lrc_back_color_double[1]=color[1];
            desktop_lrc_back_color_double[2]=color[2];
        } else {
            widget_lrc_back_color_double[0]=color[0];
            widget_lrc_back_color_double[1]=color[1];
            widget_lrc_back_color_double[2]=color[2];
        }
    }
    gdk_color.red = (guint16)(color[0]*255.0);
    gdk_color.green = (guint16)(color[1]*255.0);
    gdk_color.blue = (guint16)(color[2]*255.0);

    g_snprintf(x_color_red,30,"%x",gdk_color.red);
    g_snprintf(x_color_green,30,"%x",gdk_color.green);
    g_snprintf(x_color_blue,30,"%x",gdk_color.blue);

    if (!x_color_red[1])
        x_color_red[1]='0';
    x_color_red[2]=0;
    if (!x_color_green[1])
        x_color_green[1]='0';
    x_color_green[2]=0;
    if (!x_color_blue[1])
        x_color_blue[1]='0';
    x_color_blue[2]=0;

    strcpy(x_color,x_color_red);
    strcat(x_color,x_color_green);
    strcat(x_color,x_color_blue);

    if (type-10==1||type-100 ==1) {
        if (save_use_desktop_lrc) strcpy(desktop_lrc_color_front,x_color);
        else strcpy(widget_lrc_color_front,x_color);
    }

    if (type-10==2||type-100 ==2) {
        if (save_use_desktop_lrc) strcpy(desktop_lrc_color_back,x_color);
        else strcpy(widget_lrc_color_back,x_color);
    }


    if (save_use_desktop_lrc) {
        if (GTK_IS_WIDGET(config_button_color_front)) gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_front));
        if (GTK_IS_WIDGET(config_button_color_back))gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_back));

        if (GTK_IS_WIDGET(config_label1))gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_back));
        if (GTK_IS_WIDGET(config_label8))gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_front));

        PangoFontDescription *font_desc = pango_font_description_from_string(font_desktop_lrc);
        if (GTK_IS_WIDGET(config_label1)) gtk_widget_modify_font (config_label1, font_desc);
        if (GTK_IS_WIDGET(config_label8)) gtk_widget_modify_font (config_label8, font_desc);
        pango_font_description_free (font_desc);

        desktop_lrc_show("09");
    } else {
        if (GTK_IS_WIDGET(config_button_color_front)) gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_front));
        if (GTK_IS_WIDGET(config_button_color_back))gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_back));

        gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>菊花台</span>\n<span  foreground='#%s'>满地伤</span>\n<span  foreground='#%s'>你的笑容..</span>",widget_lrc_color_front,widget_lrc_color_back,widget_lrc_color_front));
        gtk_label_set_text((GtkLabel *) config_label8,"");

        PangoFontDescription *font_desc = pango_font_description_from_string(font_widget_lrc);
        if (GTK_IS_WIDGET(config_label1)) gtk_widget_modify_font (config_label1, font_desc);
        pango_font_description_free (font_desc);

        list_number=0;
        line_number --;
        g_timeout_add(1,(GSourceFunc)goto_line2,NULL);
    }

    if (type > 100) {
        gtk_window_set_keep_above     (GTK_WINDOW (config_dialog),TRUE);
        gtk_widget_destroy(colorselectiondialog);
        return ;
    }
}
static gvoid get_colorselection(gpointer data , gint type) {
    gtk_window_set_keep_above     (GTK_WINDOW (config_dialog),FALSE);

    GtkWidget *ok_button;
    GtkWidget *cancel_button;
    GtkWidget *help_button;
    GtkWidget *color_selection;

    colorselectiondialog = gtk_color_selection_dialog_new ("选择颜色");
    gtk_container_set_border_width (GTK_CONTAINER (colorselectiondialog), 5);
    gtk_window_set_modal (GTK_WINDOW (colorselectiondialog), FALSE);
    gtk_window_set_resizable (GTK_WINDOW (colorselectiondialog), FALSE);
    gtk_window_set_keep_above     (GTK_WINDOW (colorselectiondialog),TRUE);

    ok_button = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->ok_button;
    gtk_widget_show (ok_button);
    gtk_button_set_label ((GtkButton      *)ok_button,"确定");
    gtk_button_set_image((GtkButton      *)ok_button,gtk_image_new_from_stock("gtk-yes",GTK_ICON_SIZE_BUTTON));
    GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

    cancel_button = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->cancel_button;
    gtk_widget_show (cancel_button);
    gtk_button_set_label ((GtkButton      *)cancel_button,"取消");
    gtk_button_set_image((GtkButton      *)cancel_button,gtk_image_new_from_stock("gtk-no",GTK_ICON_SIZE_BUTTON));
    GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (cancel_button), GTK_RELIEF_NONE);

    help_button = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->help_button;
    gtk_widget_show (help_button);
    gtk_button_set_label ((GtkButton      *)help_button,"应用");
    gtk_button_set_image((GtkButton      *)help_button,gtk_image_new_from_stock("gtk-yes",GTK_ICON_SIZE_BUTTON));
    GTK_WIDGET_SET_FLAGS (help_button, GTK_CAN_DEFAULT);
    gtk_button_set_relief (GTK_BUTTON (help_button), GTK_RELIEF_NONE);

    color_selection = GTK_COLOR_SELECTION_DIALOG (colorselectiondialog)->colorsel;
    gtk_widget_show (color_selection);
    gtk_container_set_border_width (GTK_CONTAINER (color_selection), 5);
    gtk_color_selection_set_has_opacity_control (GTK_COLOR_SELECTION (color_selection), FALSE);
    gtk_color_selection_set_has_palette (GTK_COLOR_SELECTION (color_selection), TRUE);

    int color[3];
    if (save_use_desktop_lrc) {
        if (type ==1) {
            sscanf(desktop_lrc_color_front,"%02x%02x%02x",&color[0],&color[1],&color[2]);
            desktop_lrc_front_color_double[0] =( (double)color[0])/255.0;
            desktop_lrc_front_color_double[1] =( (double) color[1])/255.0;
            desktop_lrc_front_color_double[2] = ((double)color[2])/255.0;
            gtk_color_selection_set_color( (GtkColorSelection *)color_selection,desktop_lrc_front_color_double);
        }
        if (type ==2) {
            sscanf(desktop_lrc_color_back,"%02x%02x%02x",&color[0],&color[1],&color[2]);
            desktop_lrc_back_color_double[0] =( (double)color[0])/255.0;
            desktop_lrc_back_color_double[1] =( (double) color[1])/255.0;
            desktop_lrc_back_color_double[2] = ((double)color[2])/255.0;
            gtk_color_selection_set_color((GtkColorSelection *)color_selection,desktop_lrc_back_color_double);
        }
    } else {
        if (type ==1) {
            sscanf(widget_lrc_color_front,"%02x%02x%02x",&color[0],&color[1],&color[2]);
            widget_lrc_front_color_double[0] =( (double)color[0])/255.0;
            widget_lrc_front_color_double[1] =( (double) color[1])/255.0;
            widget_lrc_front_color_double[2] = ((double)color[2])/255.0;
            gtk_color_selection_set_color( (GtkColorSelection *)color_selection,widget_lrc_front_color_double);
        }
        if (type ==2) {
            sscanf(widget_lrc_color_back,"%02x%02x%02x",&color[0],&color[1],&color[2]);
            widget_lrc_back_color_double[0] =( (double)color[0])/255.0;
            widget_lrc_back_color_double[1] =( (double) color[1])/255.0;
            widget_lrc_back_color_double[2] = ((double)color[2])/255.0;
            gtk_color_selection_set_color((GtkColorSelection *)color_selection,widget_lrc_back_color_double);
        }
    }

    g_signal_connect((gpointer) help_button ,"clicked" ,G_CALLBACK(set_color),(gpointer )type+10);
    g_signal_connect((gpointer) ok_button ,"clicked" ,G_CALLBACK(set_color),(gpointer )(type+100));
    g_signal_connect((gpointer) cancel_button ,"clicked" ,G_CALLBACK(set_color),(gpointer )0);

    gtk_dialog_run((GtkDialog *)colorselectiondialog);
}
static gvoid on_config_entry_desktop_lrc_back_png_file_set() {
    if (GTK_IS_FILE_CHOOSER(config_entry_desktop_lrc_back_png)) {
        gchar *a= gtk_file_chooser_get_filename (GTK_FILE_CHOOSER(config_entry_desktop_lrc_back_png));
        if (a)strcpy(desktop_lrc_back_png,a);
    }
}
gvoid config_waiter() {
    FILE *a  = fopen("/tmp/iceplayer_lrc_waiter","r");
    if (!a) {
        if (system("/usr/share/iceplayer/IceplayerWaiter config"));
    } else {
        fclose(a);
    }
}
gvoid Config() {
    if (!show_config_dialog) {
        config_dialog = gtk_window_new (GTK_WINDOW_TOPLEVEL);

        pthread_t id;
        unlink ("/tmp/iceplayer_lrc_waiter");
        pthread_create(&id,NULL,(void *)config_waiter,NULL);

        gtk_widget_set_size_request (config_dialog,530, 410);
        gtk_window_set_title (GTK_WINDOW (config_dialog), "配置IcePlayer");
        gtk_window_set_resizable (GTK_WINDOW (config_dialog), FALSE);

        gtk_window_set_position (GTK_WINDOW (config_dialog), GTK_WIN_POS_CENTER);
        GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
        gtk_window_set_icon(GTK_WINDOW(config_dialog),IcePlayer_icon_pixbuf);
        gtk_window_set_keep_above     (GTK_WINDOW (config_dialog),TRUE);

        fixed = gtk_fixed_new ();
        gtk_widget_show (fixed);
        gtk_container_add (GTK_CONTAINER (config_dialog), fixed);

        gint aa = 8;
        gint bb = 0;
        gint cc = 25;

        config_label2 = gtk_label_new ("\"播放列表\"字体：");
        gtk_widget_show (config_label2);
        gtk_fixed_put (GTK_FIXED (fixed), config_label2, 220, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label2, 178, 24);

        config_label3 = gtk_label_new ("\"正在播放\"字体：");
        gtk_widget_show (config_label3);
        gtk_fixed_put (GTK_FIXED (fixed), config_label3, 220, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label3, 178, 24);

        config_label4 = gtk_label_new ("\"播放状态\"字体：");
        gtk_widget_show (config_label4);
        gtk_fixed_put (GTK_FIXED (fixed), config_label4, 220, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label4, 178, 24);

        config_label5 = gtk_label_new ("\"播放时间\"字体：");
        gtk_widget_show (config_label5);
        gtk_fixed_put (GTK_FIXED (fixed), config_label5, 220, aa+cc*(bb++));
        gtk_widget_set_size_request (config_label5, 178, 24);

        config_label1 = gtk_label_new ("歌词");
        gtk_widget_show (config_label1);
        gtk_fixed_put (GTK_FIXED (fixed), config_label1, 335, 147);

        config_label8 = gtk_label_new ("歌词");
        gtk_widget_show (config_label8);
        gtk_fixed_put (GTK_FIXED (fixed), config_label8, 334, 146);

        gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_back));
        gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_front));

        bb++;
        if (save_use_desktop_lrc)config_label9 = gtk_label_new ("桌面歌词示例：");
        else config_label9 = gtk_label_new ("窗口歌词示例：");
        gtk_widget_show (config_label9);
        gtk_fixed_put (GTK_FIXED (fixed), config_label9, 220, aa+cc*(bb++)+13);
        gtk_widget_set_size_request (config_label9, 178, 24);
        bb++;
        bb++;
        bb++;
        bb++;
        if (save_use_desktop_lrc)config_label10 = gtk_label_new ("桌面歌词字体：");
        else config_label10 = gtk_label_new ("窗口歌词字体：");
        gtk_widget_show (config_label10);
        gtk_fixed_put (GTK_FIXED (fixed), config_label10, 220, aa+cc*(bb++)+13);
        gtk_widget_set_size_request (config_label10, 178, 24);

        if (save_use_desktop_lrc)config_label11 = gtk_label_new ("桌面歌词颜色：");
        else  config_label11 = gtk_label_new ("窗口歌词颜色：");
        gtk_widget_show (config_label11);
        gtk_fixed_put (GTK_FIXED (fixed), config_label11, 220, aa+cc*(bb++)+13);
        gtk_widget_set_size_request (config_label11, 178, 24);

        aa = 8;
        bb = 0;
        cc = 25;
        fontbutton_treeview = gtk_font_button_new_with_font  ("sans 8");
        gtk_widget_show (fontbutton_treeview);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_treeview,364, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_treeview, 162, 24);

        fontbutton_info1 = gtk_font_button_new_with_font  ("sans 9");
        gtk_widget_show (fontbutton_info1);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_info1, 364, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_info1, 162, 24);

        fontbutton_info2 = gtk_font_button_new_with_font  ("sans 8");
        gtk_widget_show (fontbutton_info2);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_info2,364, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_info2, 162, 24);

        fontbutton_info3 = gtk_font_button_new_with_font  ("sans 7");
        gtk_widget_show (fontbutton_info3);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_info3, 364, aa+cc*(bb++));
        gtk_widget_set_size_request (fontbutton_info3, 162, 24);

        bb = bb+ 7;

        fontbutton_lrc = gtk_font_button_new_with_font  ("sans 32");
        gtk_widget_show (fontbutton_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), fontbutton_lrc,364, aa+cc*(bb++)-16);
        gtk_widget_set_size_request (fontbutton_lrc, 162, 24);

        config_button_color_front = gtk_button_new_with_label ("");
        gtk_widget_show (config_button_color_front);
        gtk_fixed_put (GTK_FIXED (fixed), config_button_color_front, 364, aa+cc*(bb)-16);
        gtk_widget_set_size_request (config_button_color_front,80,26);

        config_button_color_back = gtk_button_new_with_label ("");
        gtk_widget_show (config_button_color_back);
        gtk_fixed_put (GTK_FIXED (fixed), config_button_color_back, 446, aa+cc*(bb++)-16);
        gtk_widget_set_size_request (config_button_color_back, 80, 26);

        if (save_use_desktop_lrc) {
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_front));
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",desktop_lrc_color_back));
        } else {

            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_front)->child, g_markup_printf_escaped ("主颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_front));
            gtk_label_set_markup ((GtkLabel  *)GTK_BIN (config_button_color_back)->child, g_markup_printf_escaped ("次颜色<span  foreground='#%s'> ███</span>",widget_lrc_color_back));
        }

        config_button_lrc_justify = gtk_button_new_with_label ("");
        gtk_widget_show (config_button_lrc_justify);
        gtk_fixed_put (GTK_FIXED (fixed), config_button_lrc_justify,364, aa+cc*(bb)-14);
        gtk_widget_set_size_request (config_button_lrc_justify, 163,26);

        button = gtk_button_new ();
        gtk_widget_show (button);
        gtk_fixed_put (GTK_FIXED (fixed), button, 364, 348);
        gtk_widget_set_size_request (button, 163, 50);

        alignment1 = gtk_alignment_new (0.5, 0.5, 0, 0);
        gtk_widget_show (alignment1);
        gtk_container_add (GTK_CONTAINER (button), alignment1);

        hbox1 = gtk_hbox_new (FALSE, 2);
        gtk_widget_show (hbox1);
        gtk_container_add (GTK_CONTAINER (alignment1), hbox1);

        image1 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
        gtk_widget_show (image1);
        gtk_box_pack_start (GTK_BOX (hbox1), image1, FALSE, FALSE, 0);

        config_label6 = gtk_label_new_with_mnemonic ("确定");
        gtk_widget_show (config_label6);
        gtk_box_pack_start (GTK_BOX (hbox1), config_label6, FALSE, FALSE, 0);
        aa = 8;
        bb = 0;
        cc = 22;
        checkbutton_save_volume = gtk_check_button_new_with_mnemonic ("保存音量");
        gtk_widget_show (checkbutton_save_volume);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_volume, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_volume, 230, 24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), TRUE);

        checkbutton_show_tools = gtk_check_button_new_with_mnemonic ("显示工具条");
        gtk_widget_show (checkbutton_show_tools);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_tools, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_tools, 230, 24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), TRUE);

        checkbutton_save_file = gtk_check_button_new_with_mnemonic ("记录歌曲列表");
        gtk_widget_show (checkbutton_save_file);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_file, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_file, 230, 24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), TRUE);

        checkbutton_save_pos_size = gtk_check_button_new_with_mnemonic ("记录大小和位置");
        gtk_widget_show (checkbutton_save_pos_size);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_pos_size, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_pos_size, 230,24);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), TRUE);

        checkbutton_save_file_playing = gtk_check_button_new_with_mnemonic ("记录播放的歌曲");
        gtk_widget_show (checkbutton_save_file_playing);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_file_playing, 16, aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_file_playing, 230, 24);

        checkbutton_save_if_play = gtk_check_button_new_with_mnemonic (" 打开程序即播放");
        gtk_widget_show (checkbutton_save_if_play);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_if_play, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_if_play, 230,24);

        checkbutton_save_play_mode = gtk_check_button_new_with_mnemonic (" 记录播放模式");
        gtk_widget_show (checkbutton_save_play_mode);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_play_mode, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_play_mode, 230,24);

        checkbutton_show_notify = gtk_check_button_new_with_mnemonic ("显示 notify-OSD");
        gtk_widget_show (checkbutton_show_notify);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_notify, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_notify, 230,24);

        checkbutton_show_min = gtk_check_button_new_with_mnemonic ("使用自动缩起");
        gtk_widget_show (checkbutton_show_min);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_min, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_min, 230,24);

        checkbutton_show_lrc = gtk_check_button_new_with_mnemonic ("使用歌词");
        gtk_widget_show (checkbutton_show_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_show_lrc, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_show_lrc, 230,24);

        checkbutton_save_use_desktop_lrc = gtk_check_button_new_with_mnemonic ("当前状态:使用桌面歌词");
        gtk_widget_show (checkbutton_save_use_desktop_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_use_desktop_lrc, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_use_desktop_lrc, 230,24);

        checkbutton_save_download_lrc = gtk_check_button_new_with_mnemonic ("使用歌词下载功能");
        gtk_widget_show (checkbutton_save_download_lrc);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_download_lrc, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_download_lrc, 230,24);

        if (save_download_lrc_path)checkbutton_save_download_lrc_path = gtk_check_button_new_with_mnemonic ("当前状态:下载歌词到歌曲所在目录");
        else checkbutton_save_download_lrc_path = gtk_check_button_new_with_mnemonic ("当前状态:下载歌词到指定目录");
        gtk_widget_show (checkbutton_save_download_lrc_path);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_download_lrc_path, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_download_lrc_path, 230,24);

        config_entry_download_lrc_path = gtk_file_chooser_button_new ("指定歌词下载目录", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
        gtk_widget_show (config_entry_download_lrc_path);
        gtk_fixed_put (GTK_FIXED (fixed), config_entry_download_lrc_path, 36,aa+cc*(bb++));
        gtk_widget_set_size_request (config_entry_download_lrc_path, 140,24);
        if (!save_download_lrc_path&&download_lrc_path[0])
            gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(config_entry_download_lrc_path),download_lrc_path);

        checkbutton_save_desktop_lrc_back_png = gtk_check_button_new_with_mnemonic ("桌面歌词背景(重新播放生效)");
        gtk_widget_show (checkbutton_save_desktop_lrc_back_png);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_desktop_lrc_back_png, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_desktop_lrc_back_png, 230,24);

        config_entry_desktop_lrc_back_png = gtk_file_chooser_button_new ("选择桌面歌词背景", GTK_FILE_CHOOSER_ACTION_OPEN);
        gtk_widget_show (config_entry_desktop_lrc_back_png);
        gtk_fixed_put (GTK_FIXED (fixed), config_entry_desktop_lrc_back_png, 36,aa+cc*(bb++));
        gtk_widget_set_size_request (config_entry_desktop_lrc_back_png, 140,24);

        GtkFileFilter* filter = gtk_file_filter_new();
        gtk_file_filter_set_name(filter, "png文件");
        gtk_file_filter_add_pattern(filter,"*.[Pp][Nn][Gg]");
        gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(config_entry_desktop_lrc_back_png),filter);
        if (desktop_lrc_back_png[0])
            gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(config_entry_desktop_lrc_back_png),desktop_lrc_back_png);

        checkbutton_save_lrc_no_has_press_event = gtk_check_button_new_with_mnemonic ("桌面歌词鼠标穿透");
        gtk_widget_show (checkbutton_save_lrc_no_has_press_event);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_lrc_no_has_press_event, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_lrc_no_has_press_event, 230,24);

        checkbutton_save_widget_lrc_keep_above = gtk_check_button_new_with_mnemonic ("窗口歌词总在最前");
        gtk_widget_show (checkbutton_save_widget_lrc_keep_above);
        gtk_fixed_put (GTK_FIXED (fixed), checkbutton_save_widget_lrc_keep_above, 16,aa+cc*(bb++));
        gtk_widget_set_size_request (checkbutton_save_widget_lrc_keep_above, 230,24);

        button_reset = gtk_button_new ();
        gtk_widget_show (button_reset);
        gtk_fixed_put (GTK_FIXED (fixed), button_reset, 280, 365);
        gtk_widget_set_size_request (button_reset, 70, 26);
        alignment2 = gtk_alignment_new (0.5, 0.5, 0, 0);
        gtk_widget_show (alignment2);
        gtk_container_add (GTK_CONTAINER (button_reset), alignment2);

        hbox2 = gtk_hbox_new (FALSE, 2);
        gtk_widget_show (hbox2);
        gtk_container_add (GTK_CONTAINER (alignment2), hbox2);

        image2 = gtk_image_new_from_stock ("gtk-undo", GTK_ICON_SIZE_BUTTON);
        gtk_widget_show (image2);
        gtk_box_pack_start (GTK_BOX (hbox2), image2, FALSE, FALSE, 0);

        config_label7 = gtk_label_new_with_mnemonic ("默认..");
        gtk_widget_show (config_label7);
        gtk_box_pack_start (GTK_BOX (hbox2), config_label7, FALSE, FALSE, 0);

        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file), save_file);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_pos_size), save_pos_size);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_tools), show_tools);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_volume), save_volume);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_file_playing),save_file_playing);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_if_play),save_if_play);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_play_mode),save_play_mode);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_notify),show_notify);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_min),show_min);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_show_lrc),show_lrc);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_lrc_no_has_press_event),save_lrc_no_has_press_event);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc),save_download_lrc);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_use_desktop_lrc),save_use_desktop_lrc);
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_widget_lrc_keep_above),save_widget_lrc_keep_above);

        if (save_download_lrc_path) {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc_path),TRUE);
            gtk_widget_set_sensitive (config_entry_download_lrc_path,FALSE);
        } else {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_download_lrc_path),FALSE);
            gtk_widget_set_sensitive (config_entry_download_lrc_path,TRUE);
        }
        if (save_desktop_lrc_back_png) {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_desktop_lrc_back_png),TRUE);
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,TRUE);
        } else {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_save_desktop_lrc_back_png),FALSE);
            gtk_widget_set_sensitive (config_entry_desktop_lrc_back_png,FALSE);
        }

        if (font_treeview[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_treeview,font_treeview);
        if (font_info1[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info1,font_info1);
        if (font_info2[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info2,font_info2);
        if (font_info3[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_info3,font_info3);
        if (save_use_desktop_lrc) {
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_use_desktop_lrc)->button),"当前状态:使用桌面歌词");
            if (font_desktop_lrc[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,font_desktop_lrc);
        } else {
            gtk_button_set_label(&(((GtkToggleButton *)checkbutton_save_use_desktop_lrc)->button),"当前状态:使用窗口歌词");
            if (font_widget_lrc[0])gtk_font_button_set_font_name((GtkFontButton   *)fontbutton_lrc,font_widget_lrc);
        }

        if (save_use_desktop_lrc) {
            gtk_fixed_move (GTK_FIXED (fixed), config_label1, 365, 177);
            gtk_fixed_move (GTK_FIXED (fixed), config_label8, 364, 176);
            gtk_label_set_text((GtkLabel *) config_label9,"桌面歌词示例：");
            gtk_label_set_text((GtkLabel *) config_label10,"桌面歌词字体：");
            gtk_label_set_text((GtkLabel *) config_label11,"桌面歌词颜色：");
            gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_back));
            gtk_label_set_markup ((GtkLabel  *)config_label8, g_markup_printf_escaped ("<span  foreground='#%s'>歌词</span>",desktop_lrc_color_front));
            PangoFontDescription *font_desc = pango_font_description_from_string(font_desktop_lrc);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
            if (GTK_IS_WIDGET(config_label8))gtk_widget_modify_font (config_label8, font_desc);
            pango_font_description_free (font_desc);
            switch (desktop_lrc_justify) {
            case GTK_JUSTIFY_LEFT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"桌面歌词行数：单行");
                break;
            case GTK_JUSTIFY_RIGHT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"桌面歌词行数：双行");
                break;
            }

        } else {
            gtk_fixed_move (GTK_FIXED (fixed), config_label1, 365, 107);

            PangoFontDescription *font_desc = pango_font_description_from_string(font_widget_lrc);
            if (GTK_IS_WIDGET(config_label1))gtk_widget_modify_font (config_label1, font_desc);
            pango_font_description_free (font_desc);
            gtk_label_set_markup ((GtkLabel  *)config_label1, g_markup_printf_escaped ("<span  foreground='#%s'>菊花台</span>\n<span  foreground='#%s'>满地伤</span>\n<span  foreground='#%s'>你的笑容..</span>",widget_lrc_color_front,widget_lrc_color_back,widget_lrc_color_front));
            gtk_label_set_text((GtkLabel *) config_label8,"");
            gtk_label_set_text((GtkLabel *) config_label9,"窗口歌词示例：");
            gtk_label_set_text((GtkLabel *) config_label10,"窗口歌词字体：");
            gtk_label_set_text((GtkLabel *) config_label11,"窗口歌词颜色：");
            switch (widget_lrc_justify) {
            case GTK_JUSTIFY_LEFT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：左对齐");
                break;
            case GTK_JUSTIFY_RIGHT:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：右对齐");
                break;
            case GTK_JUSTIFY_CENTER:
                gtk_button_set_label((GtkButton *)config_button_lrc_justify,"窗口歌词对齐：居中");
                break;
            }
        }

        g_signal_connect ((gpointer) config_dialog, "delete_event",G_CALLBACK ( close_config_dialog),NULL);
        g_signal_connect ((gpointer) fontbutton_treeview, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )1);
        g_signal_connect ((gpointer) fontbutton_info1, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )2);
        g_signal_connect ((gpointer) fontbutton_info2, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )3);
        g_signal_connect ((gpointer) fontbutton_info3, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )4);
        g_signal_connect ((gpointer) fontbutton_lrc, "font_set",G_CALLBACK (on_fontbutton_font_set),(gpointer )5);
        g_signal_connect ((gpointer) checkbutton_save_volume, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )2);
        g_signal_connect ((gpointer) checkbutton_show_tools, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )3);
        g_signal_connect ((gpointer) checkbutton_save_file, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )4);
        g_signal_connect ((gpointer) checkbutton_save_pos_size, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )5);
        g_signal_connect ((gpointer) checkbutton_save_file_playing, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )6);
        g_signal_connect ((gpointer) checkbutton_save_if_play, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )7);
        g_signal_connect ((gpointer) checkbutton_save_play_mode, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )8);
        g_signal_connect ((gpointer) checkbutton_show_notify, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )9);
        g_signal_connect ((gpointer) checkbutton_show_min, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )10);
        g_signal_connect ((gpointer) checkbutton_show_lrc, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )11);
        g_signal_connect ((gpointer) checkbutton_save_lrc_no_has_press_event, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )12);
        g_signal_connect ((gpointer) checkbutton_save_download_lrc, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )13);
        g_signal_connect ((gpointer) checkbutton_save_download_lrc_path, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )14);
        g_signal_connect ((gpointer) checkbutton_save_desktop_lrc_back_png, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )15);
        g_signal_connect ((gpointer) checkbutton_save_use_desktop_lrc, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )16);
        g_signal_connect ((gpointer) checkbutton_save_widget_lrc_keep_above, "toggled",G_CALLBACK (on_checkbutton_toggled),(gpointer )17);
        g_signal_connect ((gpointer) config_button_color_front,"clicked" ,G_CALLBACK( get_colorselection),(gpointer )1);
        g_signal_connect ((gpointer) config_button_color_back,"clicked" ,G_CALLBACK( get_colorselection),(gpointer )2);
        g_signal_connect ((gpointer) button,"clicked" ,G_CALLBACK( close_config_dialog),config_dialog);
        g_signal_connect ((gpointer) button_reset,"clicked" ,G_CALLBACK( on_reset_button_clicked),NULL);
        g_signal_connect ((gpointer) config_entry_desktop_lrc_back_png,"file_set" ,G_CALLBACK( on_config_entry_desktop_lrc_back_png_file_set),NULL);

        g_signal_connect ((gpointer) config_button_lrc_justify,"clicked" ,G_CALLBACK( on_justify_button_clicked),NULL);

        show_iceplayer=TRUE;
        gtk_window_set_focus ((GtkWindow *)config_dialog,button);


        fclose(fopen("/tmp/iceplayer_lrc_waiter","w"));
        gtk_widget_show(config_dialog);

        show_config_dialog = TRUE;
    }
}
gvoid read_config() {

    gchar data[2000];
    save_file=save_pos_size=show_tools=save_volume=save_file_playing=save_play_mode=show_notify=show_min=show_lrc=save_download_lrc_path=save_download_lrc=save_use_desktop_lrc=save_widget_lrc_keep_above=TRUE;
    save_lrc_no_has_press_event=  save_if_play=save_desktop_lrc_back_png=FALSE;
    strcpy(desktop_lrc_color_front,"B19356");
    strcpy(desktop_lrc_color_back,"000000");
    strcpy(widget_lrc_color_front,"5A2EC6");
    strcpy(widget_lrc_color_back,"5BA000");
    strcpy(font_desktop_lrc,"sans 32");
    strcpy(font_widget_lrc,"sans 16");
    strcpy(font_treeview,"sans 8");
    strcpy(font_info1,"sans 9");
    strcpy(font_info2,"sans 8");
    strcpy(font_info3,"sans 7");
    desktop_lrc_justify = GTK_JUSTIFY_RIGHT;
    widget_lrc_justify = GTK_JUSTIFY_CENTER;

    desktop_lrc_x = 0;
    desktop_lrc_y= 0;
    widget_lrc_x = 166;
    widget_lrc_y = 172;
    widget_lrc_width = 368;
    widget_lrc_heigth = 447;

    FILE *fileconfig = fopen(config_file_path,"r");
    if (fileconfig==NULL||fgets(data,2000,fileconfig)==NULL) {
        g_print("新建配置\n");
        FILE * fileconfig = fopen(config_file_path,"a+");
        fputs(reset_config,fileconfig);

        gchar filename[2000];

        FILE *filelst = fopen(list_file_path,"a+");
        while (fgets(filename,2000,filelst)) {
            filename[strlen(filename)-1] = '\0';
            add_to_list(treeview,filename,0);
            if (fgets(filename,2000,filelst)) {};
        }
        if (fileconfig) {
            fclose(fileconfig);
            fileconfig=0;
        }
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (0,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        PangoFontDescription *pfd;
        pfd = pango_font_description_from_string("sans 8");
        if (GTK_IS_WIDGET(treeview))gtk_widget_modify_font(GTK_WIDGET(treeview),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 9");
        if (GTK_IS_WIDGET(label_info))gtk_widget_modify_font(GTK_WIDGET(label_info),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 8");
        if (GTK_IS_WIDGET(label_info2))gtk_widget_modify_font(GTK_WIDGET(label_info2),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 7");
        if (GTK_IS_WIDGET(label_info3))gtk_widget_modify_font(GTK_WIDGET(label_info3),pfd);
        pango_font_description_free(pfd);
        pfd = pango_font_description_from_string("sans 32");
        if (GTK_IS_WIDGET(desktop_lrc_label))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label),pfd);
        if (GTK_IS_WIDGET(desktop_lrc_label2))gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label2),pfd);
        if (GTK_IS_WINDOW(desktop_lrc_window)) gtk_window_resize((GtkWindow   *)desktop_lrc_window,1,1);
        pango_font_description_free(pfd);

        gtk_window_resize ( (GtkWindow *)IcePlayer,300,480);
        gtk_window_move( (GtkWindow *)IcePlayer,538,172);

        view();
        return ;
    }
    if (fileconfig) {
        fclose(fileconfig);
        fileconfig=0;
    }
    fileconfig = fopen(config_file_path,"r");
    while (fgets(data,2000,fileconfig)) {
        g_print("读取配置\n");
        //列表
        g_print("\t列表  \n");
        while (data[0] == '#') {
            if (fgets(data,2000,fileconfig)) {};
        }
        if ( data[0]=='1') {
            save_file=TRUE;
        } else {
            save_file=FALSE;
        }
        GtkListStore *store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)));
        gtk_list_store_clear(store);
        if (save_file==TRUE) {
            gchar filename[2000];
            FILE *filelst = fopen(list_file_path,"a+");
            while (fgets(filename,2000,filelst)) {
                filename[strlen(filename)-1] = '\0';
                add_to_list(treeview,filename,0);
                if (fgets(filename,2000,filelst)) {};
            }
            if (filelst) {
                fclose(filelst);
                filelst=0;
            }
        } else {
            unlink(list_file_path);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存位置?
        g_print("\t保存位置  \n");
        while (data[0] == '#') {
            if (fgets(data,2000,fileconfig)) {};
        }
        if (data==NULL)return;
        if ( data[0]=='1') save_pos_size=TRUE;
        else {
            save_pos_size=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        gint width,height,x,y;
        if (fscanf(fileconfig,"%d,%d,%d,%d\n",&width,&height,&x,&y)) {};
        if (save_pos_size) {
            if (width>0&&height>0)gtk_window_resize ( (GtkWindow *)IcePlayer,width,height);
            gtk_window_move( (GtkWindow *)IcePlayer,x,y);
        }
        gtk_widget_show_all(IcePlayer);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存播放位置?
        g_print("\t保存播放位置  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') {
            save_file_playing=TRUE;
        } else {
            save_file_playing=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //打开既播放?
        g_print("\t打开既播放  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') {
            save_if_play=TRUE;
        } else {
            save_if_play=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示tools？
        g_print("\t显示tools？  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') {
            show_tools=TRUE;
        } else {
            show_tools=FALSE;
        }
        if (show_tools) {
            gtk_widget_set_size_request(fixed_list,300,30);
            gtk_widget_show(eventbox_tools_add);
            gtk_widget_show(eventbox_tools_dele);
            gtk_widget_show(eventbox_tools_list);
            gtk_widget_show(eventbox_tools_mode);
        } else {
            gtk_widget_set_size_request(fixed_list,300,11);
            gtk_widget_hide(eventbox_tools_add);
            gtk_widget_hide(eventbox_tools_dele);
            gtk_widget_hide(eventbox_tools_list);
            gtk_widget_hide(eventbox_tools_mode);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存音量?
        g_print("\t保存音量  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        if ( data[0]=='1') save_volume=TRUE;
        else {
            save_volume=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //音量
        g_print("\t音量  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]= '\0';
        if (save_volume)volume = ((gdouble)atoi(data))/100.0;
        else volume = 1.0;
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //列表框字体
        g_print("\t列表框字体  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_treeview,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //正在播放字体
        g_print("\t正在播放字体  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_info1,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //播放状态字体
        g_print("\t播放状态字体  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_info2,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //播放时间字体
        g_print("\t播放时间字体  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_info3,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //桌面歌词字体
        g_print("\t桌面歌词字体  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_desktop_lrc,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //窗口歌词字体
        g_print("\t窗口歌词字体  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        strcpy(font_widget_lrc,data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //保存正在播放的文件
        g_print("\t保存正在播放的文件  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_file_playing=TRUE;
        } else {
            save_file_playing=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //歌曲序号
        g_print("\t歌曲序号  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        list_number =0;
        gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
        if (save_file_playing) {
            data[strlen(data)-1]='\0';
            int a= atoi(data);
            if (list_number>0) {
                if (a<list_number) {
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (a,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
                } else {
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (list_number-1,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
                }
            }
        } else {
            if (list_number>0) {
                gtk_tree_view_set_cursor((GtkTreeView *) treeview,(GtkTreePath *)gtk_tree_path_new_from_indices (0,-1), gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            }
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_if_play=TRUE;
        } else {
            save_if_play=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //播放模式
        g_print("\t播放模式  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_play_mode=TRUE;
        } else {
            save_play_mode=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        data[strlen(data)-1]='\0';
        if (save_play_mode) {
            play_type =atoi(data);
        } else {
            play_type = 0;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示notify
        g_print("\t显示notify  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            show_notify=TRUE;
        } else {
            show_notify=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //自动缩放
        g_print("\t自动缩放  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            show_min=TRUE;
        } else {
            show_min=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示歌词
        g_print("\t显示歌词  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            show_lrc=TRUE;
        } else {
            show_lrc=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //鼠标穿透
        g_print("\t鼠标穿透  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_lrc_no_has_press_event=TRUE;
        } else {
            save_lrc_no_has_press_event=FALSE;
        }
        //歌词位置
        g_print("\t歌词位置  \n");
        if (fscanf(fileconfig,"%d,%d\n",&desktop_lrc_x,&desktop_lrc_y)) {};
        if (fscanf(fileconfig,"%d,%d,%d,%d\n",&widget_lrc_x,&widget_lrc_y,&widget_lrc_width,&widget_lrc_heigth)) {};

        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //桌面歌词前景色
        g_print("\t桌面歌词前景色  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0])strcpy(desktop_lrc_color_front,data);
        else  strcpy(desktop_lrc_color_front,"B19356");
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //桌面歌词背景色
        g_print("\t桌面歌词背景色  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0])strcpy(desktop_lrc_color_back,data);
        else  strcpy(desktop_lrc_color_back,"000000");
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //窗口歌词前景色
        g_print("\t窗口歌词前景色  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0])strcpy(widget_lrc_color_front,data);
        else  strcpy(widget_lrc_color_front,"5A2EC6");
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //窗口歌词背景色
        g_print("\t窗口歌词背景色  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0])strcpy(widget_lrc_color_back,data);
        else  strcpy(widget_lrc_color_back,"5BA000");
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //歌词下载功能
        g_print("\t歌词下载功能  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0]=='1')save_download_lrc=TRUE;
        if (data[0]=='0')save_download_lrc=FALSE;
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //歌词下载目录
        g_print("\t歌词下载目录  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0]=='1')save_download_lrc_path=TRUE;
        else {
            save_download_lrc_path=FALSE;
            strcpy(download_lrc_path,data);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //使用桌面歌词背景
        g_print("\t使用桌面歌词背景  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if (data[0]=='0')save_desktop_lrc_back_png = FALSE;
        else {
            save_desktop_lrc_back_png = TRUE;
            strcpy(desktop_lrc_back_png,data);
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //显示歌词
        g_print("\t显示歌词  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_use_desktop_lrc=TRUE;
        } else {
            save_use_desktop_lrc=FALSE;
        }
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //桌面歌词对齐方式
        g_print("\t桌面歌词对齐方式  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        desktop_lrc_justify = atoi(data);
        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //窗口歌词对齐方式
        g_print("\t窗口歌词对齐方式  \n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        widget_lrc_justify = atoi(data);

        if (fgets(data,2000,fileconfig));
        if (data==NULL)return;
        if ((!data[0])&&data[1]) {
            return ;
        }
        //窗口歌词是否保持最上
        g_print("\t窗口歌词是否保持最上\n");
        while (data[0] == '#') {
            if (!fgets(data,2000,fileconfig)) {
                return;
            };
        }
        if (data==NULL)return;
        data[strlen(data)-1]='\0';
        if ( data[0]=='1') {
            save_widget_lrc_keep_above=TRUE;
        } else {
            save_widget_lrc_keep_above=FALSE;
        }

        break ;
    }

    if (fileconfig) {
        fclose(fileconfig);
        fileconfig=0;
    }
}
gvoid save_config() {
    gtk_window_set_focus(GTK_WINDOW(IcePlayer),treeview);
    unlink(config_file_path);
    FILE *  fileconfig = fopen(config_file_path,"a+");
    fputs("#此文件为IcePlayer的配置文件，几个变量顺序不变就行,“#”开头的将忽略，空行值为0\n",fileconfig);
    fputs("#是否保存播放列表，1为保存，0为不保存。\n",fileconfig);
    if (save_file) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否保存窗口大小位置，1为保存，0为不保存。\n",fileconfig);
    if (save_pos_size) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#大小位置(width,height,x,y)\n",fileconfig);
    gint width,height,x,y;
    gchar A[40];
    gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    if (height!=3) {
        g_snprintf(A,40,"%d,%d,%d,%d\n",width,height,x,y);
    } else {
        g_snprintf(A,40,"%d,%d,%d,%d\n",width,height2,x,y);
    }
    fputs(A,fileconfig);
    fputs("#是否保存正在播放的歌曲，1为保存，0为不保存。\n",fileconfig);
    if (save_file_playing) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否保存播放状态，1为保存，0为不保存。\n",fileconfig);
    if (save_if_play) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否显示工具条，1为显示，0为不显示。\n",fileconfig);
    if (show_tools) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#是否保存音量，1为保存，0为不保存。\n",fileconfig);
    if (save_volume) {
        fputs("1\n",fileconfig);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#音量\n",fileconfig);
    if (save_volume) {
        fprintf(fileconfig,"%f\n",volume*100.0);
    } else {
        fputs("0\n",fileconfig);
    }
    fputs("#列表框的字体和大小\n",fileconfig);
    if (font_treeview[0]) {
        fputs(font_treeview,fileconfig);
    } else {
        fputs(  "sans 8 " ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#“正在播放“文本框的字体和大小\n",fileconfig);
    if (font_info1[0]) {
        fputs(font_info1,fileconfig);
    } else {
        fputs( "sans 9 ",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#“播放状态“文本框的字体和大小\n",fileconfig);
    if (font_info2[0]) {
        fputs(font_info2,fileconfig);
    } else {
        fputs( " sans 8 " ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#”播放时间“文本框的字体和大小\n",fileconfig);
    if (font_info3[0]) {
        fputs(font_info3,fileconfig);
    } else {
        fputs("sans 7" ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#桌面歌词字体大小\n",fileconfig);
    if (font_desktop_lrc[0]) {
        fputs(font_desktop_lrc,fileconfig);
    } else {
        fputs("sans 32" ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#窗口歌词字体大小\n",fileconfig);
    if (font_desktop_lrc[0]) {
        fputs(font_widget_lrc,fileconfig);
    } else {
        fputs("sans 16" ,fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#是否保存选中的歌曲以便下次打开时选中？1为保存，0为不保存.\n",fileconfig);
    if (save_file_playing) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#播放歌曲的序号，0为第一首\n",fileconfig);
    if (play_path) {
        GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
        gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
        char b[100];
        strcpy(b,gtk_tree_path_to_string(play_path));
        int a= atoi(b);
        if (a<list_number) {
            fputs(gtk_tree_path_to_string(play_path),fileconfig);
        } else {
            g_snprintf(b,100,"%d",list_number);
            fputs(b,fileconfig);
        }
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#是否打开就播放？1是，0否。\n",fileconfig);
    if (save_if_play) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#记录播放模式？1为保存，0为不保存\n",fileconfig);
    if (save_play_mode) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#播放模式 0为顺序 1为随机 2为单曲 3为循环\n",fileconfig);
    fprintf(fileconfig,"%d\n",play_type);
    fputs("#显示notify? 1为显示 0为不显示\n",fileconfig);
    if (show_notify) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#自动缩进？1 是 0 否\n",fileconfig);
    if (show_min) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#使用歌词？1 是 0 否\n",fileconfig);
    if (show_lrc) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fputs("#歌词鼠标穿透？1 是 0 否\n",fileconfig);
    if (save_lrc_no_has_press_event) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);
    fprintf(fileconfig,"%d,%d\n",desktop_lrc_x,desktop_lrc_y);
    fprintf(fileconfig,"%d,%d,%d,%d\n",widget_lrc_x,widget_lrc_y,widget_lrc_width,widget_lrc_heigth);
    fputs("#桌面歌词主颜色\n",fileconfig);
    fputs(desktop_lrc_color_front,fileconfig);
    fputs("\n",fileconfig);
    fputs("#桌面歌词次颜色\n",fileconfig);
    fputs(desktop_lrc_color_back,fileconfig);
    fputs("\n",fileconfig);

    fputs("#窗口歌词主颜色\n",fileconfig);
    fputs(widget_lrc_color_front,fileconfig);
    fputs("\n",fileconfig);
    fputs("#窗口歌词次颜色\n",fileconfig);
    fputs(widget_lrc_color_back,fileconfig);
    fputs("\n",fileconfig);

    fputs("#是否使用歌词下载功能?1 是 0否。\n",fileconfig);
    if (save_download_lrc) fputs("1",fileconfig);
    else fputs("0",fileconfig);
    fputs("\n",fileconfig);
    if (GTK_IS_FILE_CHOOSER(config_entry_download_lrc_path))strcpy(download_lrc_path,gtk_file_chooser_get_current_folder (GTK_FILE_CHOOSER(config_entry_download_lrc_path)));
    fputs("#是否将歌词下载于歌曲目录?1是 或 指定目录。\n",fileconfig);
    if (save_download_lrc_path)  fputs("1",fileconfig);
    else fputs(download_lrc_path,fileconfig);
    fputs("\n",fileconfig);
    fputs("#是否使用桌面歌词背景？0否或指定png(如 /home/slax/图片/1.png )\n",fileconfig);
    if (!save_desktop_lrc_back_png)  fputs("0",fileconfig);
    else fputs(desktop_lrc_back_png,fileconfig);
    fputs("\n",fileconfig);

    fputs("# 1 使用桌面歌词,0 使用窗口歌词\n",fileconfig);
    if (save_use_desktop_lrc) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);

    fputs("# 桌面歌词(0)单(1)双行 \n",fileconfig);
    fprintf(fileconfig,"%d\n",desktop_lrc_justify);

    fputs("# 窗口歌词对齐方式0左1右2居中\n",fileconfig);
    fprintf(fileconfig,"%d\n",widget_lrc_justify);

    fputs("# 窗口歌词总在最上(1)\n",fileconfig);
    if (save_widget_lrc_keep_above) {
        fputs("1",fileconfig);
    } else {
        fputs("0",fileconfig);
    }
    fputs("\n",fileconfig);

    fputs("# e-mail:jasy.ice@163.com qq:173870074 2010 GPL\n",fileconfig);
    if (fileconfig) {
        fclose(fileconfig);
        fileconfig=0;
    }
}
