#include "widget_lrc.h"
gvoid press_desktop_lrc(GtkWidget *widget,GdkEventButton *event,gpointer data) {
    if (save_lrc_no_has_press_event)return ;
    if (event->button==1) {
        desktop_lrc_moveing=TRUE;
        gtk_window_begin_move_drag(GTK_WINDOW(desktop_lrc_window),event->button,event->x_root,event->y_root,event->time);
    } else {
        gvoid on_tray_menu_event(gint type);
        on_tray_menu_event(0);
    }
}
gvoid release_desktop_lrc() {
    desktop_lrc_moveing=FALSE;
    gtk_window_get_position( (GtkWindow *)desktop_lrc_window,&desktop_lrc_x,&desktop_lrc_y);
}
gvoid set_input_shape_mask () {/**///鼠标穿透
    GdkPixmap *input_mask = gdk_pixmap_new (NULL, 1, 1, 1);
    GdkGC *gc = gdk_gc_new (input_mask);
    GdkColor color;
    color.pixel = 1.0;
    gdk_gc_set_foreground (gc, &color);
    gdk_draw_rectangle (input_mask, gc, TRUE, 0, 0, 1, 1);
    gtk_widget_input_shape_combine_mask (desktop_lrc_window, NULL, 0, 0);
    gtk_widget_input_shape_combine_mask (desktop_lrc_window, input_mask, 0, 0);
    g_object_unref (input_mask);
    g_object_unref (gc);
}
gboolean on_window_expose_event(GtkWidget * widget, GdkEventExpose * event, gpointer data) {
    cairo_t *cr;
    cr = gdk_cairo_create(widget->window);
    cairo_set_source_rgba (cr, 0.0, 0.0, 0.0, 1.0);
    cairo_set_source_surface(cr, lrc_image, 0, 0);

    cairo_set_operator(cr, CAIRO_OPERATOR_SOURCE);
    cairo_paint(cr);
    cairo_destroy(cr);

    return FALSE;
}
gvoid close_desktop_lrc() {
    if (GTK_IS_WINDOW(desktop_lrc_window)) {
        gtk_widget_destroy(desktop_lrc_window);
    }
    desktop_lrc_window = 0;
}
gdouble desktop_show_lrc_time;
gvoid desktop_show_lrc2 (gchar lrc[2000]) {

    if (desktop_lrc_justify==GTK_JUSTIFY_LEFT) {//单行
        PangoFontDescription *pfd;
        pfd = pango_font_description_from_string(font_desktop_lrc);
        gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label),pfd);
        gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label2),pfd);
        pango_font_description_free(pfd);
        int a,b,c;
        int d,e,f;
        sscanf(line[line_number-1],"[%d:%d.%d]",&d,&e,&f);
        sscanf(line[line_number],"[%d:%d.%d]",&a,&b,&c);

        desktop_show_lrc_time=a*60+b+(double)c*0.01-d*60-e-(double)f*0.01;
    }
}
gvoid desktop_lrc_show (gchar lrc[2000]) {/**///画公仔的
    if (!save_use_desktop_lrc) {
        close_desktop_lrc();
        return ;
    }
    static gchar lrc2[2000];
    gchar lrc3[2000];
    if (lrc[0])strcpy(lrc3,lrc);
    else lrc3[0]=0;

    if (lrc[0]=='0'&&lrc[1]=='9') {
        if (lrc2[0] == 0)strcpy(lrc3,"");
        if (lrc2[0])strcpy(lrc3,lrc2);
    } else {
        if (lrc[0])strcpy(lrc2,lrc);
    }

    if (!GTK_IS_WIDGET(desktop_lrc_window)) {
        gchar lrc_image_path[2000];
        FILE *lrc_image_file;
        if (desktop_lrc_back_png!=NULL&&save_desktop_lrc_back_png) {
            strcpy(lrc_image_path ,desktop_lrc_back_png);
            lrc_image_file= fopen(lrc_image_path,"r");
        } else {
            lrc_image_file =0 ;
        }

        if (lrc_image_file) {
            lrc_image = cairo_image_surface_create_from_png(lrc_image_path);
            fclose(lrc_image_file);
            lrc_image_path[0] =0;
        } else {
            lrc_image = cairo_image_surface_create( CAIRO_FORMAT_ARGB32, 0, 0);
        }
        desktop_lrc_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
        gtk_window_set_keep_above     (GTK_WINDOW (desktop_lrc_window),TRUE);
        gtk_window_set_skip_taskbar_hint(GTK_WINDOW(desktop_lrc_window),TRUE);
        gtk_window_stick (GTK_WINDOW(desktop_lrc_window));
        gtk_window_set_decorated(GTK_WINDOW(desktop_lrc_window), FALSE);
        gtk_window_move((GtkWindow *)desktop_lrc_window,desktop_lrc_x,desktop_lrc_y);
        gtk_widget_set_app_paintable(desktop_lrc_window, TRUE);

        desktop_lrc_fixed = gtk_fixed_new();
        gtk_widget_show(desktop_lrc_fixed);
        gtk_container_add((GtkContainer *)desktop_lrc_window,( GtkWidget       *)desktop_lrc_fixed);

        desktop_lrc_label2 = gtk_label_new(lrc);
        gtk_widget_show(desktop_lrc_label2);
        gtk_fixed_put( (GtkFixed  *)desktop_lrc_fixed,desktop_lrc_label2,1,1);

        GtkWidget * lrc_eventbox=gtk_event_box_new();
        gtk_event_box_set_visible_window( (GtkEventBox *)lrc_eventbox,FALSE);
        gtk_widget_show(lrc_eventbox);
        gtk_fixed_put( (GtkFixed  *)desktop_lrc_fixed,lrc_eventbox,0,0);

        desktop_lrc_label = gtk_label_new(lrc3);
        gtk_widget_show(desktop_lrc_label);
        gtk_container_add((GtkContainer *)lrc_eventbox,( GtkWidget       *)desktop_lrc_label);

        PangoFontDescription *pfd;
        pfd = pango_font_description_from_string(font_desktop_lrc);
        gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label),pfd);
        gtk_widget_modify_font(GTK_WIDGET(desktop_lrc_label2),pfd);
        pango_font_description_free(pfd);

        lrc_screen = gtk_widget_get_screen(desktop_lrc_window);
        lrc_colormap = gdk_screen_get_rgba_colormap(lrc_screen);
        gtk_widget_set_colormap(desktop_lrc_window, lrc_colormap);
        g_signal_connect(G_OBJECT(desktop_lrc_window), "expose-event",G_CALLBACK(on_window_expose_event), NULL);
        g_signal_connect(G_OBJECT(desktop_lrc_window), "delete-event",G_CALLBACK(close_desktop_lrc), NULL);
        g_signal_connect(G_OBJECT(lrc_eventbox), "button_press_event",G_CALLBACK(press_desktop_lrc), NULL);
        g_signal_connect(G_OBJECT(desktop_lrc_window), "focus_in_event",G_CALLBACK(release_desktop_lrc), NULL);
        gtk_widget_show_all(desktop_lrc_window);
        gtk_window_move((GtkWindow *)desktop_lrc_window,desktop_lrc_x,desktop_lrc_y);
    }
    if (lrc3[0]) {
        gtk_label_set_markup ((GtkLabel  *)desktop_lrc_label, g_markup_printf_escaped ("<span  foreground='#%s'>%s</span>",desktop_lrc_color_front,lrc3));
        gtk_label_set_markup ((GtkLabel  *)desktop_lrc_label2, g_markup_printf_escaped ("<span  foreground='#%s'>%s</span>",desktop_lrc_color_back,lrc3));
    }

    if (save_lrc_no_has_press_event)set_input_shape_mask();
    else gtk_widget_input_shape_combine_mask (desktop_lrc_window, NULL, 0, 0);
    if (!desktop_lrc_moveing)gtk_window_resize((GtkWindow   *)desktop_lrc_window,1,1);
    if (!desktop_lrc_moveing)gtk_window_move((GtkWindow *)desktop_lrc_window,desktop_lrc_x,desktop_lrc_y);

    return ;
}
gvoid change_desktop_lrc_has_press_event() {
    save_lrc_no_has_press_event=!save_lrc_no_has_press_event;
    desktop_lrc_show("09");
}
gvoid desktop_lrc_run() {/**///解析并提交显示
    if (!show_lrc) {
        close_desktop_lrc();
        return;
    }

    gchar A[60];
    g_snprintf(A,60,"%02u[%02u:%02u.%02u]",GST_TIME_ARGS(pos));
    gint n=0;
    while (n!= 12) {
        A[n] = A[n+2];
        n++;
    }
    A[n-1]= '\0';
    if ( (strncmp(A,line[line_number],9)>=0&&strncmp(A,line[line_number+1],9)<0)|| (line[line_number][0]!=0&&strncmp(A,line[line_number],9)>=0&&line[line_number+1][0]==0) ) {
        gchar tmp[4000];
        if (desktop_lrc_justify) {
            gchar tmp2[4000];

            if (line_number%2) {

                n=0;
                while (line[line_number][n+9]) {
                    tmp[n]= line[line_number][n+10];
                    n++;
                }
                tmp[n]=0;
                n=0;
                while (line[line_number+1][n+9]) {
                    tmp2[n]= line[line_number+1][n+10];
                    n++;
                }
                tmp2[n]=0;

            } else {
                n=0;
                while (line[line_number][n+9]) {
                    tmp2[n]= line[line_number][n+10];
                    n++;
                }
                tmp2[n]=0;
                n=0;
                while (line[line_number+1][n+9]) {
                    tmp[n]= line[line_number+1][n+10];
                    n++;
                }
                tmp[n]=0;
            }
            strcat(tmp,"\n");
            strcat(tmp,tmp2);
            desktop_lrc_show(tmp);
        } else {
            gchar tmp[2000];
            n=0;
            while (line[line_number][n+9]) {
                tmp[n]= line[line_number][n+10];
                n++;
            }
            desktop_lrc_show(tmp);
        }

        line_number++;
    } else {
        if (strncmp(A,line[line_number],9)>=0&&line[line_number+1][0]!=0&&strncmp(A,line[line_number+1],9)>=0) {
            while (strncmp(A,line[line_number],9)>=0&&strncmp(A,line[line_number+1],9)>=0) {
                line_number++;
                if (strncmp(A,line[line_number],9)>=0&&strncmp(A,line[line_number+1],9)<0) {
                    return ;
                }
                if (line[line_number][0]==0) {
                    line_number = 0;
                    return ;
                }
            }
        } else {
            if (line_number-2>=0&&strncmp(A,line[line_number-2],9)<0&&strncmp(A,line[line_number],9)<0) {
                while (strncmp(A,line[line_number],9)<0) {
                    line_number--;
                    if (line_number<0 ) {
                        line_number = 0;
                        break;
                    }
                }
            }
        }
    }
    return ;
}
