/**//*   重要函数 感谢好友的 play_uri(); bus_call(); */
#include "list.h"
gvoid gtk_menu_popup_new (GtkMenu *menu,gint width,gint height) {/**///使一点击鼠标出现菜单时，菜单离鼠标或高或低 height 个距离
    gtk_menu_popup (GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
    gint x,y;
    gint w,h;
    gint sx,sy;
    gtk_window_get_size ( (GtkWindow *)gtk_widget_get_toplevel((GtkWidget *)menu),&w,&h);
    gdk_window_get_pointer( NULL,&x,&y,NULL);
    gtk_window_get_position( (GtkWindow *)gtk_widget_get_toplevel((GtkWidget *)menu),&sx,&sy);
    if (h>=gdk_screen_height()-y)
        gtk_window_move((GtkWindow *)gtk_widget_get_toplevel((GtkWidget *)menu),sx,sy-height);
    else
        gtk_window_move((GtkWindow *)gtk_widget_get_toplevel((GtkWidget *)menu),sx,sy+height);
    if (w>=gdk_screen_width()-x)
        gtk_window_move((GtkWindow *)gtk_widget_get_toplevel((GtkWidget *)menu),sx-width,sy);
    else
        gtk_window_move((GtkWindow *)gtk_widget_get_toplevel((GtkWidget *)menu),sx+width,sy);
}
gboolean bus_call(GstBus *bus, GstMessage *msg, gpointer user_data) {
    gvoid play_uri() ;
    switch (GST_MESSAGE_TYPE(msg)) {
    case GST_MESSAGE_ERROR:
    case GST_MESSAGE_EOS: {
        if (GTK_IS_WINDOW(desktop_lrc_window)) {
            gtk_widget_destroy(desktop_lrc_window);
        }
        desktop_lrc_window = 0;
        if (play_type==IcePlayer_Play_Mode_Normal||play_type==IcePlayer_Play_Mode_Normal_Round) {
            list_number=0;
            gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
            gtk_tree_path_next(play_path);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);

            gchar *b=gtk_tree_path_to_string(play_path);
            gint a= atoi(b);
            if (a>=list_number) {
                if (play_type==IcePlayer_Play_Mode_Normal_Round) {
                    play_path = gtk_tree_path_new_first();
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path,gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
                    play_uri();
                    return 1;
                }
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_Play_State_STOP;
                gtk_widget_set_size_request (eventbox_process_prev,7,12);
                gtk_widget_set_size_request (eventbox_process_next,193,12);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                               ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            } else {
                play_state = IcePlayer_Play_State_PLAYING;
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_uri();
            }
        }
        if (play_type==IcePlayer_Play_Mode_Radom) {
            list_number=0;
            gchar b[20];
            srand((unsigned)time(NULL)+1);
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            list_number=rand()%list_number;
            sprintf(b,"%d",list_number);
            GtkTreePath *path = gtk_tree_path_new_from_string(b);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            change_treeview_uri();
            play_path = path;
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_PLAYING;
            play_uri();
            break ;
        }
        if (play_type==IcePlayer_Play_Mode_One) {
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_PLAYING;
            play_uri();
            break ;
        }
    }
    save_config();
    break;
    default:
        if (!pipeline) break;
        vol=gst_bin_get_by_name(GST_BIN(pipeline), "volume");
        if (!vol) break;
        g_object_set(vol, "volume",volume, NULL);
        break;
    }
    return 1;
}
gvoid play_uri() {
    g_print("播放地址:%s\n",uri);
    gvoid next  () ;
    gboolean lrc();
    static gint error=0;
    gchar data[2000];
    change_treeview_uri();
    gint a = strlen(uri);
    gint b = 0;
    while (b-7<a) {
        data[b] = uri[b+7];
        b++;
    }
    FILE * file = fopen(data,"r");
    if (file) {
        if (file) {
            fclose(file);
            file=0;
        }
        /**///初始化各种状态,开始播放
        error = 0 ;
        if (loop) g_main_loop_quit(loop);
        if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_NULL);
        gchar * markup;
        markup = g_markup_printf_escaped("%s                                                                                                                          . ",name);
        gtk_label_set_markup(GTK_LABEL(label_info),markup);
        gtk_label_set_text(GTK_LABEL(label_info2),"状态：播放                                                                                                                    ");

        if (show_notify) {
            if (system("pkill notify-osd"));//ubuntu 10.04后已修补notify的bug了～～若是10.04的就删掉吧
            NotifyNotification *notify = notify_notification_new("播放", name,  "/usr/share/iceplayer/iceplayer.png", NULL);
            notify_notification_show(notify, NULL);
        }
        gtk_status_icon_set_tooltip(trayIcon,name);
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        play_state = IcePlayer_Play_State_PLAYING;
        loop = g_main_loop_new(NULL, TRUE);
        pipeline = NULL;
        pipeline = gst_element_factory_make("playbin", "player");
        g_object_set(G_OBJECT(pipeline), "uri",uri, NULL);
        strcpy(uri2,uri);
        gtk_tree_model_foreach(gtk_tree_view_get_model( (GtkTreeView *)treeview), (GtkTreeModelForeachFunc) clear_colum_one,NULL);
        GtkListStore *store = GTK_LIST_STORE(gtk_tree_view_get_model( (GtkTreeView   *)treeview));
        GtkTreeIter iter;
        gtk_tree_model_get_iter( (GtkTreeModel *)store, &iter, play_path);
        strcpy(play_name,name);
        gtk_list_store_set(store, &iter,0,name,1,"♥", -1);
        gtk_widget_set_size_request (eventbox_process_prev,7,12);
        gtk_widget_set_size_request (eventbox_process_next,193,12);
        save_config();
        GstBus *bus;
        bus = gst_pipeline_get_bus(GST_PIPELINE(pipeline));
        gst_bus_add_watch(bus, bus_call, NULL);
        gst_object_unref(bus);
        if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_PLAYING);
        pthread_t  a;
        pthread_create(&a,NULL,(gvoid *)g_main_loop_run,loop);

        if (show_lrc) {
            g_timeout_add(500,(GSourceFunc)lrc,NULL);
        }

    } else {
        list_number=0;
        gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
        gtk_tree_path_next(play_path);
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);

        gchar *b=gtk_tree_path_to_string(play_path);
        gint a= atoi(b);
        if (a>=list_number) {
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_STOP;
            gtk_widget_set_size_request (eventbox_process_prev,7,12);
            gtk_widget_set_size_request (eventbox_process_next,193,12);
            gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
            gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                               ");
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        } else {
            next();//文件不存在
        }
    }
}
gvoid hide  () {
    gtk_window_iconify (GTK_WINDOW(IcePlayer) );
}
gvoid view  () {
    gint x,y;
    show_iceplayer = TRUE;
    if (height2>=3)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    gtk_widget_hide(IcePlayer);
    gtk_widget_show(IcePlayer);
    gtk_window_move( (GtkWindow *)IcePlayer,x,y);
    if (!gtk_window_is_active((GtkWindow           *)IcePlayer)) {
        gtk_window_deiconify (GTK_WINDOW(IcePlayer) );
    }
    gtk_window_set_focus(GTK_WINDOW(IcePlayer),treeview);
}
gboolean play  () {
    g_print("播放\n");
    gvoid Open_Dialog(GtkMenuItem *item, gpointer user_data);
    if (play_state==IcePlayer_Play_State_STOP)uri[0]=0;
    change_treeview_uri();
    if (uri[0] == 0) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (list) play_path = (GtkTreePath *) list->data;
    }
    GtkTreeModel *model;
    GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
    if (list) {
        switch (play_state) {
        case IcePlayer_Play_State_PLAYING:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PAUSED);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：暂停                                                                                                                    ");
                play_state = IcePlayer_Play_State_PAUSED;
                g_object_set(vol, "volume",0.0, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_Play_State_PAUSED:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PLAYING);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：播放                                                                                                                    ");
                play_state = IcePlayer_Play_State_PLAYING;
                g_object_set(vol, "volume",volume, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_Play_State_STOP:
            play_path = (GtkTreePath *) list->data;
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            if (uri[0]) play_uri();
            break;
        }
    } else {
        switch (play_state) {
        case IcePlayer_Play_State_PLAYING:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PAUSED);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：暂停                                                                                                                    ");
                play_state = IcePlayer_Play_State_PAUSED;
                g_object_set(vol, "volume",0.0, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_Play_State_PAUSED:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PLAYING);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：播放                                                                                                                    ");
                play_state = IcePlayer_Play_State_PLAYING;
                g_object_set(vol, "volume",volume, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_Play_State_STOP:
            if (uri[0]) {
                play_uri();
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
                play_path = (GtkTreePath *) list->data;
            } else {
                GtkWidget * menu = gtk_menu_new();
                GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_mnemonic("添加文件");
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file);
                GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_mnemonic("添加文件夹");
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder);
                g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
                g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
                gtk_widget_show_all(menu);
                drag_lock=TRUE;
                gtk_menu_popup_new(GTK_MENU(menu),1,1);
                break;
            }
            break;
        }
    }
    return FALSE;
}
gvoid next  () {
    g_print("下一首\n");
    change_treeview_uri();
    if (uri[0] == 0) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (list) play_path = (GtkTreePath *) list->data;
        if (play_path) gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
        if (uri[0]) play_uri();
    } else {
        if (play_type==IcePlayer_Play_Mode_Normal||play_type==IcePlayer_Play_Mode_Normal_Round) {
            list_number=0;
            gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
            gtk_tree_path_next(play_path);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);

            gchar *b=gtk_tree_path_to_string(play_path);
            gint a= atoi(b);
            if (a>=list_number) {
                if (play_type==IcePlayer_Play_Mode_Normal_Round) {
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
                    play_uri();
                    return ;
                }
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_Play_State_STOP;
                gtk_widget_set_size_request (eventbox_process_prev,7,12);
                gtk_widget_set_size_request (eventbox_process_next,193,12);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                               ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            } else {
                play_state = IcePlayer_Play_State_PLAYING;
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_uri();
            }
        }
        if (play_type==IcePlayer_Play_Mode_Radom) {
            list_number=0;
            gchar b[4];
            srand((unsigned)time(NULL)+1);
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            list_number=rand()%list_number;
            sprintf(b,"%d",list_number);
            GtkTreePath *path = gtk_tree_path_new_from_string(b);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            change_treeview_uri();
            play_path = path;
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_PLAYING;
            play_uri();
        }
        if (play_type==IcePlayer_Play_Mode_One) {
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_PLAYING;
            play_uri();
        }

    }
}
gvoid prev  () {
    g_print("上一首\n");
    change_treeview_uri();
    if (uri[0] == 0) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (list) play_path = (GtkTreePath *) list->data;
        if (play_path) gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
        if (uri[0]) play_uri();
    } else {
        if (play_type==0) {
            list_number=0;
            gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
            if (play_path) gtk_tree_path_prev(play_path);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            gchar *b=gtk_tree_path_to_string(play_path);
            gint a= atoi(b);
            if (a>=list_number) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_Play_State_STOP;
                gtk_widget_set_size_request (eventbox_process_prev,7,12);
                gtk_widget_set_size_request (eventbox_process_next,193,12);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                   ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            } else {
                play_state = IcePlayer_Play_State_PLAYING;
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_uri();
            }
        }
        if (play_type==1) {
            list_number=0;
            gchar b[4];
            srand((unsigned)time(NULL)+1);
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            list_number=rand()%list_number;
            sprintf(b,"%d",list_number);
            GtkTreePath *path = gtk_tree_path_new_from_string(b);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_PLAYING;
            play_uri();
        }
        if (play_type==2) {
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_PLAYING;
            play_uri();
        }
    }
}
gvoid stop  () {
    g_print("停止\n");
    if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
    play_state = IcePlayer_Play_State_STOP;
    play_name[0] = '\0';
    gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
    image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
    gtk_widget_show(image_play);
    gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
    gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
    gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
    gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                  ");
    gtk_widget_set_size_request (eventbox_process_prev,7,12);
    gtk_widget_set_size_request (eventbox_process_next,193,12);
    if (GTK_IS_WINDOW(desktop_lrc_window)) {
        gtk_widget_destroy(desktop_lrc_window);
    }
    desktop_lrc_window = 0;
}
gvoid quit  () {

    if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_NULL);
    if (loop) g_main_loop_quit(loop);
    save_config();
    if (system("pkill notify-osd"));
    if (system("pkill IceplayerWaiter"));
    if (system("rm -rf /tmp/iceplayer*"));
    g_print("退出\n");
    /**///检查更新
    gvoid auto_Update();
    auto_Update();
    exit(0);
}


