/**//*   播放列表  */
#include "pix.h"

gvoid init_list(GtkWidget *list) {/**///不解释
    GtkCellRenderer *renderer;
    GtkListStore *store;
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeview), 0, " ", renderer, "text", 0, NULL);
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeview), 0, " ", renderer, "text", 1, NULL);
    store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gtk_tree_view_set_model(GTK_TREE_VIEW(list),GTK_TREE_MODEL(store));
    g_object_unref(store);
}
gvoid add_to_list(GtkWidget *list,gchar string[2000],gint add_type) {/**///不解释
    GtkListStore *store;
    GtkTreeIter iter;
    store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    if (add_type == 0) { /*后面*/
        gtk_list_store_append(store, &iter);
    }
    if (add_type == 1) { /*前面*/
        gtk_list_store_prepend(store, &iter);
    }
    if (add_type == 2) { /*正在播放的后面*/
        GtkTreeIter iter_select;
        GtkTreeModel *model_select;
        GList *list_select = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))),&model_select);
        if (list_select) { /*如果播放列表并无选择就插入到前面*/
            gtk_tree_model_get_iter(model_select, &iter_select, (GtkTreePath *) list_select->data);
            gtk_list_store_insert_after(store, &iter,&iter_select);
        } else {
            gtk_list_store_prepend(store, &iter);
        }
    }
    if (!strcmp(string,play_name)) {
        gtk_list_store_set(store, &iter,0,string,1,"♥", -1);
    } else {
        gtk_list_store_set(store, &iter,0,string,1," ", -1);
    }
}
gboolean get_list_number(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer user_data) {
    list_number++;
    return FALSE;
}
gboolean change_treeview_uri () {/**///将当前选中项提取 uri和name 出来
    gchar filename[2000];
    GtkTreeIter iter;
    GtkTreeModel *model;
    gchar *value;
    GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
    if (list != NULL) {
        if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
            gtk_tree_model_get(model, &iter, 0, &value, -1);
            FILE *filelst = fopen(list_file_path,"a+");
            while (fgets(filename,2000,filelst)) {
                filename[strlen(filename)-1] = '\0';
                if (!strcmp(filename,value) ) {
                    strcpy(name,filename);
                    if (fgets(filename,2000,filelst));
                    filename[strlen(filename)-1] = '\0';
                    strcpy(uri,filename);
                }
            }
            if (filelst) {
                fclose(filelst);
                filelst=0;
            }
            g_free(value);
        }
    }
    return FALSE;
}
gboolean clear_colum_one(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer user_data) {/**///清空 ♥ 号
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value,-1);
    gtk_tree_model_get_iter(model, iter, path);
    gtk_list_store_set((GtkListStore *)model, iter,0,value,1," ", -1);
    return FALSE;
}
gboolean selete_playing_low(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer user_data) {
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value,-1);
    if (!strcmp(value,play_name)) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        change_treeview_uri();
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),NULL);
        if (list) play_path = (GtkTreePath *) list->data;
        gtk_tree_model_foreach(gtk_tree_view_get_model( (GtkTreeView *)treeview), (GtkTreeModelForeachFunc) clear_colum_one,NULL);
        gtk_list_store_set((GtkListStore *)model, iter,0,play_name,1,"♥", -1);
        return TRUE;
    }
    g_free(value);
    return FALSE;
}
gboolean selete_low(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gchar va[2000]) {
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value,-1);
    if (!strcmp(value,va)) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        return TRUE;
    }
    g_free(value);
    return FALSE;
}
gboolean list_reorder(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,FILE *tmplog) {/**///同步 列表文件 和 播放列表

    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value, -1);
    gchar data[2000];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,2000,list_file)) {
        data[strlen(data)-1] = '\0';
        if (!strcmp(data,value)) {
            fputs(data,tmplog);
            fputc('\n',tmplog);
            if (fgets(data,2000,list_file));
            data[strlen(data)-1] = '\0';
            fputs(data,tmplog);
            fputc('\n',tmplog);
        }
    }
    if (list_file) {
        fclose(list_file);
        list_file=0;
    }
    g_free(value);
    return FALSE;
}
gboolean list_order_set(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter, gchar name[][2000]) {/**///正反乱序排列辅助
    static gint n=0;
    if (!name[0][0]) {
        n=0;
    }
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value, -1);
    strcpy(name[n++],value);
    name[n][0]=0;
    g_free(value);
    return FALSE;
}
gvoid List_order(GtkMenuItem *item, gint type) {/**///正反乱序排列
    gint n,m;
    list_number=0;
    gtk_tree_model_foreach( gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
    if (list_number>5000) {
        GtkWidget *dialog_real = gtk_message_dialog_new_with_markup(NULL,GTK_DIALOG_DESTROY_WITH_PARENT    ,GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK,"歌曲数目太多了！居然有<span  foreground='red'>%d</span>个！\n\n看丫的不卡死你！\n\n受不住了就清空或者删除\"~/.Iceplayer/filelist\"",list_number);
        gtk_dialog_run((GtkDialog *)dialog_real);
        gtk_widget_destroy(dialog_real);
        return ;
    }
    gchar name[list_number][2000];
    name[0][0]=0;
    gchar tmp[2000];
    GtkTreeModel *model=gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));

    gtk_tree_model_foreach( model, (GtkTreeModelForeachFunc)list_order_set,name);
    if (type != 2) {
        for (n=0;n<list_number-1;n++) {
            for (m=0;m<list_number-n-1;m++) {
                if (strcmp(name[m],name[m+1])==1) {
                    strcpy(tmp,name[m]);
                    strcpy(name[m],name[m+1]);
                    strcpy(name[m+1],tmp);
                }
            }
        }
    } else {
        srand((unsigned)time(NULL)+1);
        for (n=0;n<list_number-1;n++) {
            for (m=0;m<list_number-n-1;m++) {
                if (rand()%2) {
                    strcpy(tmp,name[m]);
                    strcpy(name[m],name[m+1]);
                    strcpy(name[m+1],tmp);
                }
            }
        }
    }
    gtk_list_store_clear(  (GtkListStore *)model);
    if (type != 2) {
        n = 0;
        while (name[n][0]) {
            add_to_list ( treeview, (name[n++]),type);
        }
    } else {
        n = 0;
        while (n<list_number&&name[n][0]) {
            add_to_list ( treeview, (name[n]),rand()%2);
            n=n+3;
        }
        n = 1;
        while (n<list_number&&name[n][0]) {
            add_to_list ( treeview, (name[n]),rand()%2);
            n=n+3;
        }
        n = 2;
        while (n<list_number&&name[n][0]) {
            add_to_list ( treeview, (name[n]),rand()%2);
            n=n+3;
        }
    }
    strcpy(tmp_file_path,g_get_tmp_dir());
    strcat(tmp_file_path,"/IcePlayer.log");
    FILE *tmplog = fopen(tmp_file_path,"a+");
    model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    gtk_tree_model_foreach(model , (GtkTreeModelForeachFunc) list_reorder,tmplog);

    if (tmplog) {
        fclose(tmplog);
        tmplog=0;
    }
    unlink(list_file_path);

    g_snprintf(tmp,2000,"cp \"%s\" \"%s\"",tmp_file_path,list_file_path);
    if (system(tmp));
    unlink(tmp_file_path);
    gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)selete_playing_low,NULL);
}
gvoid real_delete(gchar *value) {/**///不解释
    gchar data[2000];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,2000,list_file)) {
        data[strlen(data)-1] = '\0';
        if (!strcmp(data,value)) {
            if (fgets(data,2000,list_file));
            data[strlen(data)-1] = '\0';
            gint n = strlen(data);
            gint m = 0;
            while (m+7 != n) {
                data[m] = data[m+7];
                m++;
            }
            data[m] = '\0';
            unlink(data);
            gchar lrc_path[2000];

            strcpy(lrc_path,data);
            n=strlen(data);
            while (data[n]!='.')
                n--;
            lrc_path[n]='\0';
            strcat(lrc_path,".lrc");
            FILE *file = fopen (lrc_path,"r");
            if (file) {
                if (file) {
                    fclose(file);
                    file=0;
                }
                GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"是否删除对应的歌词?");
                if (gtk_dialog_run((GtkDialog *) dialog_real) ==-5) {
                    unlink(lrc_path);
                }
                gtk_widget_destroy(dialog_real);
            }
        }
    }

    if (list_file) {
        fclose(list_file);
        list_file=0;
    }
}
gvoid List_delete(GtkMenuItem *item, gpointer user_data) {/**///不解释
    gvoid stop();
    drag_lock=TRUE;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkTreeIter iter;
    GtkListStore *store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)));
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    GList *list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
    const gchar *title = gtk_label_get_label((GtkLabel  *)GTK_BIN (item)->child);
    gboolean has = FALSE;
    if (!strcmp(title,"移除选中的文件")) {
        if (list == NULL) {
            GtkWidget *dialog;
            GtkWidget *dialog_vbox;
            GtkWidget *label;
            GtkWidget *dialog_action_area;
            GtkWidget *okbutton1;
            dialog = gtk_dialog_new();
            gtk_widget_set_size_request(dialog, 180, 70);
            gtk_window_set_title(GTK_WINDOW(dialog), "");
            gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
            gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
            gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
            dialog_vbox = GTK_DIALOG(dialog)->vbox;
            gtk_widget_show(dialog_vbox);
            label = gtk_label_new("没有选中任何文件!");
            gtk_widget_show(label);
            gtk_box_pack_start(GTK_BOX(dialog_vbox), label, FALSE, FALSE, 0);
            dialog_action_area = GTK_DIALOG(dialog)->action_area;
            gtk_widget_show(dialog_action_area);
            gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_END);
            okbutton1 = gtk_button_new_from_stock("gtk-ok");
            gtk_widget_show(okbutton1);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton1, GTK_RESPONSE_OK);
            GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);
            GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
            gtk_window_set_icon(GTK_WINDOW(dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
            gtk_window_set_keep_above     (GTK_WINDOW (dialog),TRUE);
            show_iceplayer=TRUE;
            gtk_window_set_focus ((GtkWindow *)IcePlayer,okbutton1);
            gtk_dialog_run((GtkDialog *) dialog);
            gtk_widget_destroy(dialog);
            show_iceplayer=FALSE;
            return ;
        }
        while (list != NULL) {
            if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
                if ((GtkTreePath *) list->data!=NULL&&play_path!=NULL)
                    if (!gtk_tree_path_compare( (GtkTreePath *) list->data,play_path)) {
                        has=TRUE;
                    }
            }
            list = list->next;
        }
        list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
        while (list != NULL) {
            if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
                gtk_list_store_remove(store, &iter);
            }
            list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
        }
    }
    if (!strcmp(title,"移除包含\"???\"的文件")) {
        GtkWidget *dialog;
        GtkWidget *dialog_vbox;
        GtkWidget *entry;
        GtkWidget *dialog_action_area;
        GtkWidget *cancelbutton;
        GtkWidget *okbutton;
        dialog = gtk_dialog_new();
        gtk_window_set_title(GTK_WINDOW(dialog), "删除包含以下输入框中文字的文件");
        GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
        gtk_window_set_keep_above     (GTK_WINDOW (dialog),TRUE);
        gtk_window_set_icon(GTK_WINDOW(dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
        gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
        gtk_widget_set_size_request(dialog,300,-1);
        dialog_vbox = GTK_DIALOG(dialog)->vbox;
        gtk_widget_show(dialog_vbox);
        entry = gtk_entry_new();
        gtk_widget_show(entry);
        gtk_box_pack_start(GTK_BOX(dialog_vbox), entry, FALSE, FALSE, 0);
        gtk_entry_set_invisible_char(GTK_ENTRY(entry), 9679);
        dialog_action_area = GTK_DIALOG(dialog)->action_area;
        gtk_widget_show(dialog_action_area);
        gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_END);
        cancelbutton = gtk_button_new_from_stock("gtk-cancel");
        gtk_widget_show(cancelbutton);
        gtk_dialog_add_action_widget(GTK_DIALOG(dialog), cancelbutton, GTK_RESPONSE_CANCEL);
        GTK_WIDGET_SET_FLAGS(cancelbutton, GTK_CAN_DEFAULT);
        okbutton = gtk_button_new_from_stock("gtk-ok");
        gtk_widget_show(okbutton);
        gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton, GTK_RESPONSE_OK);
        GTK_WIDGET_SET_FLAGS(okbutton, GTK_CAN_DEFAULT);
        GtkAccelGroup *accel_group = gtk_accel_group_new();
        gtk_widget_add_accelerator(okbutton, "clicked", accel_group,GDK_Return, 0, GTK_ACCEL_VISIBLE);
        gtk_window_add_accel_group(GTK_WINDOW(dialog), accel_group);
        gtk_window_set_focus ((GtkWindow *)dialog,entry);
        show_iceplayer=TRUE;
        if (gtk_dialog_run((GtkDialog *) dialog) ==-5) {
            const gchar *value = gtk_entry_get_text((GtkEntry *) entry);
            if (strcmp(value,"")) {
                gtk_list_store_clear(store);
                gchar data[2000];
                FILE *list_file = fopen(list_file_path,"at+");
                while (fgets(data,2000,list_file)) {
                    data[strlen(data)-1] = '\0';
                    if (!strstr(data,value)) {
                        add_to_list(treeview,data,0);
                    } else {
                        if (!strcmp(data,play_name)) {
                            gtk_widget_hide((GtkWidget * )dialog);
                            GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"正在播放的歌曲中含有关键字，是否删除？(其余含有关键字的歌曲都将删除)");
                            if (gtk_dialog_run((GtkDialog *) dialog_real)==-5) {
                                has = TRUE;
                            } else {
                                add_to_list(treeview,play_name,0);
                            }
                            gtk_widget_destroy(dialog_real);
                        }
                    }
                    if (fgets(data,2000,list_file));
                }

                if (list_file) {
                    fclose(list_file);
                    list_file=0;
                }
            }
        }
        gtk_widget_destroy(dialog);
        show_iceplayer=FALSE;
    }
    if (!strcmp(title,"清空文件")) {
        if (play_state != IcePlayer_Play_State_PLAYING) {
            gtk_list_store_clear(store);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_Play_State_STOP;
            play_name[0] = '\0';
            uri[0] = '\0';
            gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
            gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
            gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                        ");
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        } else {
            GtkWidget *dialog;
            GtkWidget *dialog_vbox;
            GtkWidget *label;
            GtkWidget *dialog_action_area;
            GtkWidget *okbutton1;
            GtkWidget *okbutton2;
            GtkWidget *okbutton3;
            dialog = gtk_dialog_new();
            gtk_widget_set_size_request(dialog, 400,100);
            gtk_window_set_title(GTK_WINDOW(dialog), "");
            gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
            gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
            gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
            dialog_vbox = GTK_DIALOG(dialog)->vbox;
            gtk_widget_show(dialog_vbox);
            label = gtk_label_new("有文件正在播放，\n“确定”清空所有，“否”保留正在播放曲目，“取消”返回。");
            gtk_widget_show(label);
            GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
            gtk_window_set_icon(GTK_WINDOW(dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
            gtk_window_set_keep_above     (GTK_WINDOW (dialog),TRUE);
            gtk_box_pack_start(GTK_BOX(dialog_vbox), label, FALSE, FALSE, 0);
            dialog_action_area = GTK_DIALOG(dialog)->action_area;
            gtk_widget_show(dialog_action_area);
            gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_CENTER);
            okbutton1 = gtk_button_new_from_stock("gtk-ok");
            gtk_widget_show(okbutton1);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton1, GTK_RESPONSE_OK);
            okbutton2 = gtk_button_new_from_stock("gtk-no");
            gtk_widget_show(okbutton2);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton2, GTK_RESPONSE_NO);
            okbutton3 = gtk_button_new_from_stock("gtk-cancel");
            gtk_widget_show(okbutton3);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton3, GTK_RESPONSE_CANCEL);
            GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);
            show_iceplayer=TRUE;
            gtk_window_set_focus ((GtkWindow *)IcePlayer,okbutton1);
            gint a = gtk_dialog_run((GtkDialog *) dialog);
            if (a==-5) {
                gtk_list_store_clear(store);
                play_path=gtk_tree_path_new_first();
                play_name[0] = '\0';
                uri[0] = '\0';
                stop();
                gtk_widget_destroy(dialog);
                unlink(list_file_path);
                return ;
            } else {
                if (a==-9) {
                    FILE *lstfile = fopen(list_file_path,"w");
                    fprintf(lstfile,"%s\n%s\n",play_name,uri2);
                    if (lstfile) {
                        fclose(lstfile);
                        lstfile=0;
                    }

                    gtk_list_store_clear(store);
                    add_to_list(treeview,play_name,0);
                    play_path=gtk_tree_path_new_first();
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
                } else {
                    gtk_widget_destroy(dialog);
                    return ;
                }
            }
            gtk_widget_destroy(dialog);
            show_iceplayer=FALSE;
        }
    }
    if (!strcmp(title,"移除重复的文件")) {
        gtk_list_store_clear(store);
        gchar data[2000];
        FILE *list_file = fopen(list_file_path,"at+");
        strcpy(tmp_file_path,g_get_tmp_dir());
        strcat(tmp_file_path,"/IcePlayer.log");
        FILE *tmplog = fopen(tmp_file_path,"w");
        while (fgets(data,2000,list_file)) {
            data[strlen(data)-1] = '\0';
            if ((strcmp(play_name,data)==0)||(data[strlen(data)-1] != ')'&&((data[strlen(data)-3] != '('&&data[strlen(data)-4] != '^')||(data[strlen(data)-4] != '('&&data[strlen(data)-5] != '^')))) {
                add_to_list(treeview,data,0);
                fputs(data,tmplog);
                fputs("\n",tmplog);
                if (fgets(data,2000,list_file));
                data[strlen(data)-1] = '\0';
                fputs(data,tmplog);
                fputs("\n",tmplog);
                continue ;
            }
            if (fgets(data,2000,list_file));
            continue ;
        }
        if (list_file) {
            fclose(list_file);
            list_file=0;
        }
        if (tmplog) {
            fclose(tmplog);
            tmplog=0;
        }
        unlink(list_file_path);
        gchar make_new_filelst[2000];
        g_snprintf(make_new_filelst,2000,"cp \"%s\" \"%s\"",tmp_file_path,list_file_path);
        if (system(make_new_filelst));
        unlink(tmp_file_path);
    }
    if (!strcmp(title,"移除已不存在的文件")) {
        gtk_list_store_clear(store);
        gchar data[1200];
        gchar data2[1200];
        gchar data3[1200];
        FILE *list_file = fopen(list_file_path,"at+");
        while (fgets(data,1200,list_file)) {
            data[strlen(data)-1] = '\0';
            if (fgets(data2,1200,list_file));
            data2[strlen(data2)-1] = '\0';
            gint a = strlen(data2);
            gint b = 0;
            while (b-7<a) {
                data3[b] = data2[b+7];
                b++;
            }
            FILE *file =fopen(data3,"r");
            if (file) {
                if (file) {
                    fclose(file);
                    file=0;
                }
                add_to_list(treeview,data,0);
            }
        }

        if (list_file) {
            fclose(list_file);
            list_file=0;
        }
    }
    if (!strcmp(title,"物理删除选中的文件")) {
        if (list == NULL) {
            GtkWidget *dialog;
            GtkWidget *dialog_vbox;
            GtkWidget *label;
            GtkWidget *dialog_action_area;
            GtkWidget *okbutton1;
            dialog = gtk_dialog_new();
            gtk_widget_set_size_request(dialog, 180, 70);
            gtk_window_set_title(GTK_WINDOW(dialog), "");
            gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
            gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
            gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
            dialog_vbox = GTK_DIALOG(dialog)->vbox;
            gtk_widget_show(dialog_vbox);
            label = gtk_label_new("没有选中任何文件!");
            gtk_widget_show(label);
            gtk_box_pack_start(GTK_BOX(dialog_vbox), label, FALSE, FALSE, 0);
            dialog_action_area = GTK_DIALOG(dialog)->action_area;
            gtk_widget_show(dialog_action_area);
            gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_END);
            okbutton1 = gtk_button_new_from_stock("gtk-ok");
            gtk_widget_show(okbutton1);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton1, GTK_RESPONSE_OK);
            GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);
            show_iceplayer=TRUE;
            gtk_window_set_focus ((GtkWindow *)IcePlayer,okbutton1);
            gtk_dialog_run((GtkDialog *) dialog);
            show_iceplayer=FALSE;
            gtk_widget_destroy(dialog);
            return ;
        } else {
            GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"删除后无法恢复，是否确认？");
            show_iceplayer=TRUE;
            if (gtk_dialog_run((GtkDialog *) dialog_real) ==-5) {
                while (list != NULL) {
                    if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
                        gchar *value;
                        gtk_tree_model_get(model, &iter, 0, &value, -1);
                        if (!strcmp(value,play_name)) {
                            has = TRUE;
                        }
                        real_delete(value);
                        gtk_list_store_remove(store, &iter);
                    }
                    list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
                }
            }
            gtk_widget_destroy(dialog_real);
            show_iceplayer=FALSE;
            gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)selete_playing_low,NULL);
        }
    }
    if (has) {
        stop();
        play_path = gtk_tree_path_new_first ();
        gtk_tree_model_foreach(gtk_tree_view_get_model( (GtkTreeView               *)treeview), (GtkTreeModelForeachFunc) clear_colum_one,NULL);
    }
    strcpy(tmp_file_path,g_get_tmp_dir());
    strcat(tmp_file_path,"/IcePlayer.log");
    FILE *tmplog = fopen(tmp_file_path,"a+");
    gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc) list_reorder,tmplog);
    if (tmplog) {
        fclose(tmplog);
        tmplog=0;
    }
    unlink(list_file_path);
    gchar make_new_filelst[2000];
    g_snprintf(make_new_filelst,2000,"cp \"%s\" \"%s\"",tmp_file_path,list_file_path);
    if (system(make_new_filelst));
    unlink(tmp_file_path);
    if (!has)gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)selete_playing_low,NULL);
}
gboolean on_list_key_press_event(GtkWidget *treeview,GdkEventKey *event,gpointer user_data) {
    if (event->type == GDK_KEY_PRESS) {
        if (event->keyval==GDK_F2) {
            gvoid operate_file(GtkMenuItem *item, gint type);
            operate_file((GtkMenuItem *)NULL,IcePlayer_File_Operate_Rename);
            return TRUE;
        }
        if (event->keyval==GDK_Escape) {
            gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)selete_playing_low,NULL);
            return TRUE;
        }
    }
    return FALSE;
}
gboolean on_treeview_drag_drop() {

    strcpy(tmp_file_path,g_get_tmp_dir());
    strcat(tmp_file_path,"/IcePlayer.log");
    FILE *tmplog = fopen(tmp_file_path,"a+");
    gtk_tree_model_foreach( gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc) list_reorder,tmplog);
    if (tmplog) {
        fclose(tmplog);
        tmplog=0;
    }
    unlink(list_file_path);
    gchar make_new_filelst[2000];
    g_snprintf(make_new_filelst,2000,"cp \"%s\" \"%s\"",tmp_file_path,list_file_path);
    if (system(make_new_filelst));
    unlink(tmp_file_path);
    gtk_tree_model_foreach(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)selete_playing_low,NULL);
    return FALSE;
}
char * concat_uris (char **uris, gsize *length) {
    GString *string;
    gsize len;
    guint i;

    len = 0;
    for (i = 0; uris[i]; ++i)
        len += strlen (uris[i]) + 1;

    if (length)
        *length = len;

    string = g_string_sized_new (len + 1);
    for (i = 0; uris[i]; ++i) {
        g_string_append (string, uris[i]);
        g_string_append_c (string, ' ');
    }

    return g_string_free (string, FALSE);
}
void transform_uris_to_quoted_fuse_paths (char **uris) {
    guint i;

    if (!uris)
        return;
    for (i = 0; uris[i]; ++i) {

        FILE *file;

        char *path;

        file = g_file_new_for_uri (uris[i]);

        if ((path = g_file_get_path (file))) {
            char *quoted;

            quoted = g_shell_quote (path);
            g_free (uris[i]);
            g_free (path);

            uris[i] = quoted;
        }

        g_object_unref (file);
    }
}
gvoid on_treeview_drag_data_received (GtkWidget *widget, GdkDragContext *context,gint x, gint y, GtkSelectionData *selection_data, guint info, guint timestamp) {

    if (gtk_targets_include_uri (&selection_data->target, 1)) {
        char **uris;
        gsize len;

        uris = gtk_selection_data_get_uris (selection_data);
        if (!uris)
            return;
        char * concat_uris (char **uris, gsize *length);
        transform_uris_to_quoted_fuse_paths(uris);

        g_print("收到拖放文件！\n");
        GtkWidget * menu=gtk_menu_new();
        GtkWidget *add_to_front=gtk_image_menu_item_new_with_label("添加到列表最前");
        GtkWidget *add_to_select=gtk_image_menu_item_new_with_label("添加到选中项之后");
        GtkWidget *add_to_down=gtk_image_menu_item_new_with_label("添加到列表最后");

        gtk_menu_shell_append(GTK_MENU_SHELL(menu),add_to_front);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu),add_to_select);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu),add_to_down);
        gtk_widget_show(add_to_front);
        gtk_widget_show(add_to_select);
        gtk_widget_show(add_to_down);

        gvoid add_file1(GtkStatusIcon *status_icon,gchar paths[2000] );
        gvoid add_file2(GtkStatusIcon *status_icon,gchar paths[2000] );
        gvoid add_file3(GtkStatusIcon *status_icon,gchar paths[2000] );

        g_signal_connect(add_to_front,"activate",G_CALLBACK(add_file1),concat_uris(uris,&len));
        g_signal_connect(add_to_select,"activate",G_CALLBACK(add_file2),concat_uris(uris,&len));
        g_signal_connect(add_to_down,"activate",G_CALLBACK(add_file3),concat_uris(uris,&len));

        gtk_widget_show(menu);
        gtk_menu_popup (GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
    } else {
        g_print("拖放失败!不是文件而是文件夹或文字图片等?\n");
    }
}
gvoid set_drag() {
    //文件拖放
    //GtkTargetEntry dest_targets[ ] = { {(char*) "text/uri-list", 0, 0} };
    GtkTargetList* list = gtk_drag_dest_get_target_list( GTK_WIDGET (treeview));
    gtk_target_list_add_uri_targets(list,0);
    gtk_drag_dest_set_target_list( GTK_WIDGET (treeview),list);
    //gtk_drag_dest_set   ( GTK_WIDGET (treeview), 0,  dest_targets, G_N_ELEMENTS (dest_targets),GDK_ACTION_COPY );
}
gvoid unset_drag() {
    /*   gtk_drag_source_unset(treeview);*/
    /*  gtk_drag_dest_unset(treeview);*/
}

